#!/bin/python
# -*- coding: utf-8 -*-
# -----------------------------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016/2017
# -----------------------------------------------------------------------
# Python-Steuerung fuer Vorwerk-Staubsauger
# Datei : neato-vorwerk.py
# -----------------------------------------------------------------------
import serial
import sys
from optparse import OptionParser

sauger_port='/dev/ttyACM0'
sauger_cmd='help'
sauger_ports=['/dev/ttyACM0']

def send_cmd(sauger_port, sauger_cmd):
	print "DEBUG Sauger-Port=", sauger_port
	print "DEBUG sauger_cmd=", sauger_cmd
	try:
		port = serial.Serial(sauger_port)
		if port.isOpen():
			print "Port: ", sauger_port, " ist verfgbar"
			con = serial.Serial(sauger_port, 115200, timeout=1)
			print '-' * 20
                        print "Verbindung zu: ",con.portstr       #check welcher Port in Benutzung
                        print '-' * 20
			print "Befehl: ",con.write(sauger_cmd+'\015') # wichtig: immer carriage return = \015 mit dazu ;)
                        feedback  = con.read(1866) # die zeichenanzahl ggf anpassen
                        print feedback
                        print "-----------------------------------------"
                        con.close()             # port schliessen
		else:
			print "Port: ", sauger_port," ist nicht verfgbar"
	except serial.SerialException as ex:
                    print 'Port ttyACM0 ist nicht verfgbar: {1}'.format(sauger_port, ex)

if __name__=="__main__":
	parser = OptionParser()
	parser.set_defaults(sauger_port='/dev/ttyACM0')
	parser.add_option('-p', '--port', default=sauger_port, dest='sauger_port', help='Anschluss Staubsauger - default: /dev/ttyACM0')
	parser.add_option('-c', '--command', default=sauger_cmd, dest="sauger_cmd", help='Command fuer Staubsauger')
	(options, args) = parser.parse_args()
	print '=' * 80
	if options.sauger_port:
                sauger_port=options.sauger_port
                print "Port in Verwendung: ", sauger_port
	if options.sauger_cmd:
		sauger_cmd=options.sauger_cmd
		print "Befehl bergeben: ", sauger_cmd
	else:
		sauger_cmd='help'
	print '=' * 80
	#print "cmd=", sauger_cmd
# --------------------------- EOF --------------------------------------
