#!/bin/python
# -*- coding: utf-8 -*-
# -----------------------------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016/2017
# -----------------------------------------------------------------------
# Funktion neato-fahren-sauger.py
#       startet Reinigung der Wohnung und simuliert das Drcken des Buttons
import serial

def testMode(sw='off'):
#Command: TestMode
# Description: Sets TestMode on or off. Some commands can only be run in TestMode.
# Usage: TestMode [On] [Off]
        if sw == 'on' or sw =='ON' or sw =='On':
                testModeCmd='TestMode On'
        else:
                testModeCmd='TestMode Off'
        print '-' * 50
        print 'testModeCmd= ', testModeCmd
        print '-' * 50
	return testModeCmd

def setMotor(linksMM=0, rechtsMM=0, speed=0):
# fahren nur mglich, wenn testmode auf on
# Command: SetMotor
# Description: Sets the specified motor to run in a direction at a requested speed. (TestMode Only)
# Usage: SetMotor [LWheelDist <LWheelDist_value>] [RWheelDist <RWheelDist_value>] [Speed <Speed_value>] [Accel <Accel_value>] [RPM <RPM_value>] [Br$
# Options:
# Flag  Description
# linksMM = LWheelDist  Distance in millimeters to drive Left wheel. (Pos = forward, neg = backward)
# rechtsMM = RWheelDist         Distance in millimeters to drive Right wheel. (Pos = forward, neg = backward)
# Speed         Speed in millimeters/second. (Required only for wheel movements)
# Accel         Acceleration in millimeters/second.
# (Used only for wheel movements. Defaults to ^^Speed^^.)
#
# RPM   Next argument is the RPM of the motor.
# Not used for wheels, but applied to all other motors specified in the command line.
#
# Brush         Brush motor forward (Mutually exclusive with wheels and vacuum.)
# VacuumOn      Vacuum motor on (Mutually exclusive with VacuumOff)
# VacuumOff     Vacuum motor off (Mutually exclusive with VacuumOn)
# VacuumSpeed   Vacuum speed in percent (1-100).
# RWheelDisable         Disable Right Wheel motor
# LWheelDisable         Disable Left Wheel motor
# BrushDisable  Disable Brush motor
# RWheelEnable  Enable Right Wheel motor
# LWheelEnable  Enable Left Wheel motor
# BrushEnable   Enable Brush motor
# Return Format: None
	if 
        setMotorCmd='setMotor '+str(linksMM)+' '+str(rechtsMM)+' '+str(speed)
        print '-' * 50
        print 'setMotorCmd= ', setMotorCmd
        print '-' * 50
	return setMotorCmd


#-------------------------------------------------------------
con = serial.Serial('/dev/ttyACM0', 115200, timeout=1)
print "--------------------------"
print "Verbindung zu: ",con.portstr       #check welcher Port in Benutzung
print "--------------------------"

cmd=testMode('on')
print "Testmode On: ",con.write(cmd+'\015') # wichtig: immer carriage return = \015 mit dazu ;)
#cmd=setMotor(-100,-100,100) # rckwrts
#cmd=setMotor(100,100,100) # vorwrts
#cmd=setMotor(5,100,100) # drehung vorwrts links
cmd=setMotor(100,5,100)
print "Fahre 3 cm: ",con.write(cmd+'\015') # wichtig: immer carriage return = \015 mit dazu ;)
feedback  = con.read(1866) # die zeichenanzahl ggf anpassen
print "Rckmeldung : ", feedback
print "-----------------------------------------"
cmd=testMode('off')
print "Testmode Off: ",con.write(cmd+'\015') # wichtig: immer carriage return = \015 mit dazu ;)
con.close()             # port schliessen
