#!/bin/python
# -*- coding: utf-8 -*-
# -----------------------------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016/2017
# -----------------------------------------------------------------------
# Pfad: /Staubsauger
# neato-schedule.py
# ------------------------------------------------------------
# Python-Steuerung fuer Zugriff auf 
# Zeitplanung des Vorwerk-Staubsaugers
# ------------------------------------------------------------
import serial
import sys
from optparse import OptionParser
import re

sauger_port = '/dev/ttyACM0'
sauger_cmd = 'help'

def send_cmd(sauger_port, sauger_cmd):
        feedback='None'
        print "DEBUG Sauger-Port=", sauger_port
        print "DEBUG sauger_cmd=", sauger_cmd
        try:
                port = serial.Serial(sauger_port)
                if port.isOpen():
                        print "Port: ", sauger_port, " ist verfgbar"
                        con = serial.Serial(sauger_port, 115200, timeout=1)
                        print '-' * 20
                        print "Verbindung zu: ",con.portstr       #check welcher Port in Benutzung
                        print '-' * 20
                        print "Befehl: ",con.write(sauger_cmd+'\015') # wichtig: immer carriage return = \015 mit dazu ;)
                        feedback  = con.read(1866) # die zeichenanzahl ggf anpassen
                        print feedback
                        print '-' * 20
                        con.close()             # port schliessen
                else:
                        print "Port: ", sauger_port," ist nicht verfgbar"
        except serial.SerialException as ex:
                    print 'Port ttyACM0 ist nicht verfgbar: {1}'.format(sauger_port, ex)
        # feedback weiter auswerten
        # 19 Zeichen = Schedule is Enabled (0-18)
        feedbackAnzChar=int(len(feedback))
        scheduleCmd='GetSchedule'
        schedEnabledChar='Schedule is Enabled'
        scheduleCmdAnzChar=int(len(scheduleCmd))
        schedEnabledAnzChar=int(len(schedEnabledChar))
        if str(feedback[0:scheduleCmdAnzChar])==str(scheduleCmd):
                print "Aufruf war: ", feedback[0:scheduleCmdAnzChar]
                if str(feedback[scheduleCmdAnzChar+2:int(scheduleCmdAnzChar+1)+int(schedEnabledAnzChar+1)])== schedEnabledChar: # +2 wegen Carriage Return \r\n
                        schedData= feedback[int(scheduleCmdAnzChar + schedEnabledAnzChar + 4):feedbackAnzChar]# scheduleCmdAnzChar + schedEnabledAnzChar + 1
                        print '-' * 20
                        print "Schedule Daten: ", schedData
                        print "re.split \r/\n : -> ", re.split(r"\r\n", schedData)
                        print "scheduleCmdAnzChar+1", scheduleCmdAnzChar+1
                        print "schedEnabledAnzChar=", schedEnabledAnzChar
                        print "str(feedback[scheduleCmdAnzChar+2:int(scheduleCmdAnzChar+1)+int(schedEnabledAnzChar+1)])=", str(feedback[scheduleCmdAnzChar+2:int(scheduleCmdAnzChar+1)+int(schedEnabledAnzChar+1)])
                        print "feedbackAnzChar = ", feedbackAnzChar
                        print "schedEnabledAnzChar= ", schedEnabledAnzChar

if __name__=="__main__":
        parser = OptionParser()
        parser.set_defaults(sauger_port='/dev/ttyACM0')
        parser.add_option('-p', '--port', default=sauger_port, dest='sauger_port', help='Anschluss Staubsauger - default: /dev/ttyACM0')
        parser.add_option('-c', '--command', default=sauger_cmd, dest="sauger_cmd", help='Command fuer Staubsauger')
        (options, args) = parser.parse_args()
        print '=' * 80
        if options.sauger_port:
                sauger_port=options.sauger_port
                print "Port in Verwendung: ", sauger_port
        if options.sauger_cmd:
                sauger_cmd=options.sauger_cmd
                print "Befehl bergeben: ", sauger_cmd
        else:
                sauger_cmd='help'
        print '=' * 80
        #print "cmd=", sauger_cmd
        send_cmd(sauger_port, sauger_cmd)
# --------------------------- EOF --------------------------------------
