#!/bin/bash
# -----------------------------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016/2107
# -----------------------------------------------------------------------
# Definitionen
#-------------------------------------------------------------------------
EINSNULL="1>/dev/null"
ZWEINULL="2>/dev/null"
#-------------------------------------------------------------------------
# GPIO
GPIO_IMGR=23 # pin 16 - wiring pi 4
GPIO_IMGL=24 # pin 18 - wiring pi 5
GPIO_DEL=25 # pin 22 - wirng pi 6
GPIO_SHUTTER=22 # pin 15 - wiring 3
GPIO_VIDEO=17 # pin 11 - wiring 0
GPIO_LED=18 # pin 12 - wiring 1
#-------------------------------------------------------------------------
# Schalter
SW_SHOW_IMGR=0
SW_SHOW_IMGL=0
SW_SHOW_DEL=0
SW_SHUTTER=0
SW_VIDEO=0	# Druckschalter
SW_VIDEOD=0	# Videofunktion
SW_GPSD=0
SW_CONVERTER=0
# Schalterzaehler
iSW_SHOW_IMGR=0
iSW_SHOW_IMGL=0
iSW_SHOW_DEL=0
iSW_SHUTTER=0
iSW_VIDEO=0
iSW_GPSD=0
#-------------------------------------------------------------------------
# Dateihandling
ZAEHLER=0 
ZAEHLERNEU=0
DEFAULTFILE="himbeerecam.jpg"
FILE_PATH="/home/pi/IMG/"
# if [ "$(ls -A $FILE_PATH 2> /dev/null)" == "" ]; then echo "$FILE_PATH ist leer"; else echo "$FILE_PATH ist nicht leer";fi
FILEIMG="IMG_"
FILEEXTJPG=".jpg"
FILEEXTMP4=".mp4"
FILENAMEDEFAULT=$FILE_PATH$DEFAULTFILE
myindexnummer=0
#-------------------------------------------------------------------------
function fbi_init(){
        if [ -e  "/usr/bin/fbi" ]; then
			echo -e "\n\n[franzisCAM] OK, fbi bereits installiert";
        else
            echo -e "\n\n[franzisCAM] kein fbi installiert, wird nachgeholt..";
            sudo apt-get install fbi -y;
        fi
}
#-------------------------------------------------------------------------
function zaehler_init(){
	if [ -e  "/usr/bin/bc" ]; then
		echo -e "\n\n[franzisCAM] OK, bc bereits installiert";
	else
        echo -e "\n\n[franzisCAM] kein bc installiert, wird nachgeholt..";
		sudo apt-get install bc -y;
	fi
}
#-------------------------------------------------------------------------
function raspivid_init(){
	if [ -e  "/usr/bin/raspivid" ]; then
		echo -e "\n\n[franzisCAM] OK, raspivid ist installiert";
		SW_VIDEOD=1;
	else
		error_exit "\n\n[franzisCAM] raspivid ist nicht installiert.. Keine Video-Aufnahmen moeglich!";
		SW_VIDEOD=0;
	fi;
}
#-------------------------------------------------------------------------
function converter_init(){
        if [ -e  "/usr/bin/MP4Box" ]; then
                echo -e "\n\n[franzisCAM] OK, Konverter gpac bereits installiert";
        else
        echo -e "\n\n[franzisCAM] kein Konverter gpac installiert, wird nachgeholt..";
                sudo apt-get install gpac -y;
        fi
	if [ -e  "/usr/bin/MP4Box" ]; then SW_CONVERTER=1; fi;
}
#-------------------------------------------------------------------------
function setnew_zaehler(){
	#echo "set new zaehler:" $FILE_PATH$FILEIMG*$FILEEXTJPG
	#IMG alleine	ZAEHLERAKTUELL=`ls -tr $FILE_PATH$FILEIMG*$FILEEXTJPG | tail -1 | cut -d '_' -f 2 | cut -d '.' -f 1`;
	if [ "$(ls -A $FILE_PATH 2> /dev/null)" == "" ]; then 
		echo "[franzisCAM] $FILE_PATH ist leer"; 
		ZAEHLERNEU=0;
		ZAEHLERAKTUELL=0;
	else 
		echo "[franzisCAM] $FILE_PATH ist nicht leer";
		ZAEHLERAKTUELL=`ls -tr $FILE_PATH$FILEIMG* $FILE_VID_PATH$FILEVID* | tail -1 | cut -d '_' -f 2 | cut -d '.' -f 1`;
		if [ ! -z "$ZAEHLERAKTUELL" ]; then
			ZAEHLERNEU=`echo $ZAEHLERAKTUELL+1 | bc`;
		else
			ZAEHLERNEU=0;
		fi;
	fi;
	# echo "ZAEHLERAKTUELL =" $ZAEHLERAKTUELL;
	# echo "ZZAEHLERNEU=" $ZAEHLERNEU;
}
#-------------------------------------------------------------------------
function video_init(){
#	FILENAMEVID=$FILE_VID_PATH$FILEVID$ZAEHLERNEU$FILEEXTh264;
	FILE_VID_PATH="/home/pi/IMG/"
	FILEVID="VID_"
	FILEEXTMP4=".MP4"
	FILEEXTh264=".h264"
	# 1920 1080 mit Bitrate von 7Mbs entspricht Dateigroesse von ca.115 MByte pro Minute
	VID_BREITE="1280" # w-standard 1920
	VID_HOEHE="720" # h 
	VID_BITRATE="9110000" # Bitrate
	# 9110000 ist bitrate von 9110 Kbs (kilo bits pro sekunde) bzw. 9 Mb (9 megabits /sekunde). 
	# raspivid-Standard ist 17000000
	VID_PARTS_SECS="15000" # Videogroesse eines Blocks in Sekunden - hier 15 Sekunden
	# 60000 ms = 60 sec = 1 Minute
	SD_VID_LIMIT=8000000
	# setze die Speicherbeschraenkung hier auf 8 GByte, da "nur" 16GByte Karte zum Einsatz kommt
	converter_init;
}
#-------------------------------------------------------------------------
function gpsd_init(){
	# GPS angeschlossen?
	TXT="[franzisCAM] init_gps gestartet"
	if [ "$(ls /dev/ttyUSB0)" ]; then
		TXT="${TXT}  -> GPS-USB-Stick an franzisCAM angeschlossen"
		if [ -e  "/usr/bin/gpsd" ]; then
			echo -e "\n\n[franzisCAM] OK, GPS Daemon bereits installiert";
			sudo killall gpsd;	# gps Bug, neustart
			sudo gpsd /dev/ttyUSB0 -F /var/run/gpsd.sock; # 
		else
			echo -e "\n\n[franzisCAM] kein GPS Daemon  installiert, wird nachgeholt..";
			sudo apt-get install gpsd -y;
			sudo killall gpsd;	# gps Bug, neustart
			sudo gpsd /dev/ttyUSB0 -F /var/run/gpsd.sock;
			LONGITUDE=`gpspipe -w -n 5 | grep lon | grep -i -m 1 tpv | cut -d ',' -f 8 | cut -d ':' -f 2`;
			LATITUDE=`gpspipe -w -n 5 | grep lat | grep -i -m 1 tpv | cut -d ',' -f 7 | cut -d ':' -f 2`;
			DATE_FILE=`date +%Y-%m-%d_%H-%M`;
			DATE_EXIF=`date +%Y:%m:%d`;
			TIME_EXIF=`date +%H:%M:%S`;
			echo -e "\n\n[franzisCAM] GPS-Parameter gesetzt.";
		fi;
	#sudo apt-get install libimage-exiftool-perl
		if [ -e  "/usr/bin/exiftool" ]; then
			echo -e "\n\n[franzisCAM] OK, exiftool bereits installiert";
		else
			echo -e "\n\n[franzisCAM] kein exiftool installiert, wird nachgeholt..";
			sudo apt-get install libimage-exiftool-perl -y;
		fi;
		iSW_GPSD=1;	
	else
		TXT="${TXT}  -> kein GPS-USB-Stick an franzisCAM angeschlossen";
		iSW_GPSD=0;
	fi;
	echo ${TXT};
}
#-------------------------------------------------------------------------
function gpio_init(){
	gpio_export $GPIO_IMGR
	gpio_configure_input $GPIO_IMGR

	gpio_export $GPIO_IMGL
	gpio_configure_input $GPIO_IMGL

	gpio_export $GPIO_DEL
	gpio_configure_input $GPIO_DEL

	gpio_export $GPIO_SHUTTER
	gpio_configure_input $GPIO_SHUTTER

	gpio_export $GPIO_VIDEO
	gpio_configure_input $GPIO_VIDEO

	gpio_export $GPIO_LED
	gpio_configure_output $GPIO_LED
}
#-------------------------------------------------------------------------
function gpio_configure_output() {
	if [ -e "/sys/class/gpio/gpio${1}/direction" ]; then
		echo "out" > "/sys/class/gpio/gpio${1}/direction";
	fi
}
#-------------------------------------------------------------------------
function gpio_configure_input() {
	if [ -e "/sys/class/gpio/gpio${1}/direction" ]; then
		echo "in" > "/sys/class/gpio/gpio${1}/direction";
	fi
}
#-------------------------------------------------------------------------
function gpio_export() {
	echo -n "exporting gpio $1"
	if [ -e "/sys/class/gpio/gpio${1}/" ]; then
		echo "...gpio${1} already exists";
	else
		echo
		echo "${1}" > "/sys/class/gpio/export";
	fi
}
#-------------------------------------------------------------------------
function gpio_unexport() {
	echo -n "unexporting gpio $1";
	if [ -e "/sys/class/gpio/gpio${1}/" ]; then
		echo
		echo "${1}" > "/sys/class/gpio/unexport";
	else
		echo "-> gpio${1} does not exist";
	fi
}
#-------------------------------------------------------------------------
function check_raspicam_2(){
	echo "[franzisCAM] Check ob Raspberry Pi Kamera angeschlossen.";
	if [ "`vcgencmd get_camera`" = "supported=1 detected=1" ]; then
		echo -e "\n\n[franzisCAM] OK, RaspiCAM ist installiert.";
	else
		error_exit "\n\n[franzisCAM] Keine Kamera installiert. Bitte erst installieren.";
	fi
}
#-------------------------------------------------------------------------
function check_raspicam(){
	echo "[franzisCAM] Check ob Raspberry Pi Kamera angeschlossen.";
	if [ -e "/home/pi/test.jpg" ]; then rm /home/pi/test.jpg; fi;
	raspistill -o /home/pi/test.jpg;
 	if [ -e "/home/pi/test.jpg" ]; then
        echo;
		echo -e "\n\n[franzisCAM] OK, RaspiCAM ist installiert.";
    else
		error_exit "\n\n[franzisCAM] Keine Kamera installiert. Bitte erst installieren.";
    fi;
}
#-------------------------------------------------------------------------
function toggle_gpio(){
	gport=$1;
	if ! [ -d /sys/class/gpio/gpio$gport ]; then
		echo "$gport" > /sys/class/gpio/export;
		echo "out" > /sys/class/gpio/gpio$gport/direction;
	fi;
	gstatus=$2;
	if [ $gstatus -gt 1 ]; then
		gstatus=1;
	fi;
	echo "$gstatus" > /sys/class/gpio/gpio$gport/value;
}
#-------------------------------------------------------------------------
function exif2image(){
	# Pruefung ob GPS aktiv?
	if [ "$iSW_GPSD" -eq 0 ]; then # kein GPS
		echo "[franzisCAM] Kein GPS installiert.";
	else
		# gps aktiv
		echo "[franzisCAM] Derzeitige GPS-Position: $LONGITUDE Laengengrad und $LATITUDE Breitengrad";
		echo "[franzisCAM] Es wird $FILE verarbeitet am $DATE_EXIF $TIME_EXIF";
		if [ "$FILENAMEIMG" ]; then
		tmpFILENAMEIMG="tmp.jpg"
		# echo "TEMP DATEI" = $tmpFILENAMEIMG
	        exiftool -overwrite_original -xmp:dateTimeOriginal="$DATE_EXIF $TIME_EXIF" -GPSLongitudeRef=E -GPSLongitude=$LONGITUDE -GPSLatitudeRef=N -GPSLatitude=$LATITUDE $FILENAMEIMG -o $tmpFILENAMEIMG;
		mv $tmpFILENAMEIMG $FILENAMEIMG -f;
       	else
       		error_exit "[franzisCAM] Kann keine EXIF-Informationen der Aufnahme hinzufuegen, da keine Aufnahme vorhanden! Abbruch.";
		fi;
	fi;
}
#-------------------------------------------------------------------------
function takeSnapshot() {
	# eigenbau franzisCAM -n
	setnew_zaehler;
	FILENAMEIMG=$FILE_PATH$FILEIMG$ZAEHLERNEU$FILEEXTJPG;
	if [ -e  "/usr/bin/franzisCAM" ]; then
		echo -e "\n\n[franzisCAM] OK, franzisCAM bereits installiert";
		franzisCAM -n -o $FILENAMEIMG;
		exif2image;
		echo "[franzisCAM] Aufnahme:" $FILEIMG$ZAEHLERNEU$FILEEXTJPG " wurde auf der Speicherkarte gespeichert";
	else
        echo -e "\n\n[franzisCAM] kein franzisCAM installiert, Pruefung ob raspistill vorhanden..";
		if [ -e  "/usr/bin/raspistill" ]; then
			echo -e "\n\n[franzisCAM] OK, raspistill ist installiert";
			raspistill -o $FILENAMEIMG #raspistill -n -o $FILENAMEIMG;
			exif2image;
			echo "[franzisCAM] Aufnahme:" $FILEIMG$ZAEHLERNEU$FILEEXTJPG " wurde auf der Speicherkarte gespeichert";
		else
			error_exit "\n\n[franzisCAM] Weder franzisCAM noch raspistill installiert.. Keine Aufnahmen moeglich!";
		fi;
	fi;
}
#-------------------------------------------------------------------------
function inc_switch(){
        local name_switch=${1};
        local switch_wert=${2};
        # echo "Uebergeben wurde :" $name_switch " und " $switch_wert;
        local switch_wertneu=0;
        if [ ! -z "$switch_wert" ]; then
                local switch_wertneu=`echo $switch_wert+1 | bc`;
        fi;
        case "$name_switch" in
                "SW_SHOW_IMGR") # SW_SHOW_IMGR
#               iSW_SHOW_IMGR=$switch_wertneu;
#               echo "IMGR+1"
                iSW_SHOW_IMGR=$switch_wertneu
                ;;

                "SW_SHOW_IMGL") # SW_SHOW_IMGL
                iSW_SHOW_IMGL=$switch_wertneu
                ;;

                "SW_SHOW_DEL") # SW_DEL_IMG
                iSW_SHOW_DEL=$switch_wertneu
                ;;

                "SW_SHUTTER") # SW_SHUTTER
                iSW_SHUTTER=$switch_wertneu
                ;;

                "SW_VIDEO") # SW_VIDEO
                iSW_VIDEO=$switch_wertneu
                ;;
        esac
}
#-------------------------------------------------------------------------
function desc_switch(){
        local name_switch=${1};
        local switch_wert=${2};
        echo "Uebergeben wurde :" $name_switch " und " $switch_wert;
        local switch_wertneu=0;
        if [ ! -z "$switch_wert" ]; then
                local switch_wertneu=`echo $switch_wert-1 | bc`;
        fi
        if [ "$switch_wertneu" -lt 0 ]; then
                switch_wertneu=0;
        fi
        case "$name_switch" in
                "SW_SHOW_IMGR") # SW_SHOW_IMGR
#               iSW_SHOW_IMGR=$switch_wertneu;
#               echo "IMGR-1"
                iSW_SHOW_IMGR=$switch_wertneu
                ;;

                "SW_SHOW_IMGL") # SW_SHOW_IMGL
                iSW_SHOW_IMGL=$switch_wertneu 
                ;;

                "SW_SHOW_DEL") # SW_DEL_IMG
                iSW_SHOW_DEL=$switch_wertneu
                ;;

                "SW_SHUTTER") # SW_SHUTTER
                iSW_SHUTTER=$switch_wertneu
                ;;

                "SW_VIDEO") # SW_VIDEO
                iSW_VIDEO=$switch_wertneu
                ;;
        esac
}
#-------------------------------------------------------------------------
function showImage() {
	# wegen memory fehler vorsichtshalber offene Framebuffer entfernen
	sudo killall -9 fb 2>/dev/null;
	sudo killall -9 omxplayer 2>/dev/null;
	if cd $FILE_PATH; then
		#hole Filenamen zu Indexnummer
		#Bekannt: $myindexnumber
		#local showIMGfile=$(getFileNameFromIndex);
		# local showIMGfile=$(getFileNameFromIndex) $myindexnumber
		getFileNameFromIndex $myindexnumber;
		echo "[franzisCAM] Anzeige der Datei " $showIMGfile;
		showExtension=`echo -e $showIMGfile | cut -d '.' -f 2`;
		if [[ "$showExtension" = *jpg* ]]; then
			sudo fbi -T 1 -a $showIMGfile 2>/dev/null;
		# echo "[franzisCAM] Anzeige von: $showIMGfile";
		# eventuell mit Pfad zusammen dann aufrufen von Bildanzeige
		elif [[ "$showExtension" = *mp4* ]]; then
        		# echo "Ist MP4";
			sudo omxplayer $showIMGfile 2 >/dev/null;
		elif [[ "$showExtension" = *h264* ]]; then
			sudo omxplayer $showIMGfile 2 >/dev/null;
		        echo "Ist h264";
		else
		        echo "keinzulaaessiges Dateiformat erkannt";
		fi;
	else
		error_exit "[franzisCAM] Kann nicht das Verzeichnis wechseln! Abbruch.";
	fi
}
#-------------------------------------------------------------------------
function deleteImage() {
	cd $FILE_PATH;
	#hole Filenamen zu Indexnummer
	#Bekannt: $myindexnumber
	#local showIMGfile=$(getFileNameFromIndex);
	# local showIMGfile=$(getFileNameFromIndex) $myindexnumber
	if cd $FILE_PATH; then
		getFileNameFromIndex $myindexnumber;
		rm $showIMGfile -f 2>/dev/null;
		echo "[franzisCAM] $showIMGfile wurde geloescht";
	else
		error_exit "[franzisCAM] Kann nicht das Verzeichnis wechseln! Abbruch."
	fi
}
#-------------------------------------------------------------------------
# Hilfskruecke fuer Dateinamen in 
# function showImage benoetigt
function getFileNameFromIndex() {
	cd $FILE_PATH;
	if cd $FILE_PATH; then
#		local arr=( $(ls $FILEIMG*$FILEEXTJPG -atr 2>/dev/null ));
# local arr=( $(ls $FILE_PATH$FILEIMG* $FILE_VID_PATH$FILEVID* -atr 2>/dev/null ));
local arr=( $(ls $FILEIMG* $FILEVID* -atr 2>/dev/null ));
		if [ ${#arr[@]} = "0" ]; then 
			#local myfilename= 'himbeerecam.jpg'
			local myfilename=$FILENAMEDEFAULT;
		else
			#local myfilename =${arr[$myindexnumber]}
			echo "[franzisCAM] DATEINAME =" ${arr[${1}]};
			myfilename=`echo ${arr[${1}]}`
			#local myfilename =${arr[${1}]};
		fi;
		echo "[franzisCAM] Index: $myindexnumber Dateiname: $myfilename";
		showIMGfile=$myfilename;
	else
		error_exit "[franzisCAM] Kann nicht das Verzeichnis wechseln! Abbruch.";
	fi

}
#-------------------------------------------------------------------------
function showSplashImage() {
	local myfilename=$DEFAULTFILE;
	echo "[franzisCAM] $myfilename";
	showIMGfile=$myfilename;
}
#-------------------------------------------------------------------------
function getIndexNumberLast() {
	#if [ `find $FILE_PATH -type f | wc -l` = "0" ]; then 
	if [ "$(ls -A $FILE_PATH 2> /dev/null)" == "" ]; then 
		echo "[franzisCAM] Keine Dateien vorhanden in" $FILE_PATH;
		myindexnumber='0'; 
	else 
#		local arr=( $(ls $FILEIMG*$FILEEXTJPG -atr 2>/dev/null ))
		local arr=( $(ls $FILEIMG* $FILEVID* -atr 2>/dev/null ));
		if [ ${#arr[@]} = "0" ]; then
			myindexnumber='0';
		else
			# myindexnumber=${#arr[@]}; absolute Anzahl
			myindexnumber=`echo ${#arr[@]}-1 | bc`;
		fi;
	fi;
	echo "[franzisCAM] getIndexNumberLast -Zeiger: $myindexnumber";
}
#-------------------------------------------------------------------------
function getIndexNumberFirst() {
        myindexnumber=0;
        echo "[franzisCAM] Zeiger: $myindexnumber";
}
#-------------------------------------------------------------------------
function error_exit
{
	echo "$1" 1>&2;
	exit 1;
}
#-------------------------------------------------------------------------
function recordVideo(){
	setnew_zaehler; # funktion noch auf video anpassen!
	FILENAMEVID=$FILE_VID_PATH$FILEVID$ZAEHLERNEU$FILEEXTh264;
	# Benoetigten Speicherbedarf bestimmen
	SD_USED=$(sudo du $FILE_VID_PATH | tail -1 | awk '{print $1}');
	echo "[franzisCAM} Videos benoetigen" $SD_USED " Speicherplatz";
	# Speicher freiraeumen falls notwendig
	# echo "[franzisCAM] SD_VID_LIMIT" $SD_VID_LIMIT
	while [ $SD_VID_LIMIT -le "$SD_USED" ]
	do
		remove=$(ls -1tr $FILE_VID_PATH | grep $FILEEXTh264 | head -n 1);
		echo `date +%s` "-" $remove;
		rm $FILE_VID_PATH/$remove;
		# Freien Speicherplatz neu berechnen
		SD_USED=$(du $FILE_VID_PATH | tail -1 | awk '{print $1}');
	done
	raspivid -o $FILENAMEVID -w $VID_BREITE -h $VID_HOEHE -b $VID_BITRATE -t $VID_PARTS_SECS;
}
#-------------------------------------------------------------------------
function convert_h264_2_MP4(){
        cd /home/pi/IMG;
		vidarr=( $(ls VID*.h264 -atr 2>/dev/null ));
		# altes Zeuchs loeschen
        if [ "$SW_CONVERTER" -eq 1 ]; then
                echo "[franzisCAM] Converter MP4Box ist installiert.";
		if [ ${#vidarr[@]} = "0" ]; then
			echo "[franzisCAM] Keine Datei vorhanden";
		else
			for i in ${vidarr[@]}
			do
				echo "[franzisCAM] Datei $i wird konvertiert....";
				#MP4Box -fps 25 -add VID_*.h264 VID_*.mp4
				j=`echo -e $i | cut -d '.' -f 1`;
				j=$j".mp4";
				# MP4Box -fps 25 -add $i $j -quiet 2 >/dev/null;
				sudo MP4Box -fps 25 -add $i $j ;
				echo "[franzisCAM] Konvertierte Datei $i wird gelscht....";
				rm $i -f 2>/dev/null;
			done
		fi
        else
                echo "[franzisCAM] Converter MP4Box ist nicht installiert.";
        fi
}
#-------------------------------------------------------------------------
function set_franziscam(){
	local reboot_required=0;
	local file_init="/etc/inittab";
	local line_init="1:2345:respawn:/sbin/getty -noclear 38400 tty1";
	local line_init_replace="# 1:2345:respawn:/sbin/getty -noclear 38400 tty1";
	# Zeile suchen
	echo -n "[franzisCAM] Pruefe ${file_init}...";
	# local linenumber=`cat "${file_init}" | grep -nx "1:2345:respawn:/sbin/getty -noclear 38400 tty1" | sed -n 's/^\([0-9]*\)[:].*/\1/p'`;
	local linenumber=`cat "${file_init}" | grep -nx "$line_init" | sed -n 's/^\([0-9]*\)[:].*/\1/p'`;
	if [ "${linenumber}" == "72" ]; then # Am Ende der Datei
		echo "[franzisCAM] Erstelle Backup ${file_init}.bak...";
		sudo cp ${file_init} ${file_init}.bak;
		if [ $? == 0 ]; then
			echo -n "[franzisCAM] Aktualisiere ${file_init}...";
			#sed -i '72s/.*/# 1:2345:respawn:/sbin/getty -noclear 38400 tty1/' /etc/inittab;
			sudo sed -i '72s/.*/$line_init_replace/' /etc/inittab;
			if [ $? == 0 ]; then
				echo "[franzisCAM] OK";
				reboot_required=1;
			else
				echo "[franzisCAM] Fehler!";
				echo "[franzisCAM] Backup wird genutzt!";
				sudo mv ${file_init}.bak ${file_init};
			fi;
		fi;
	else
		#local linenumber_patched=`cat "${file_init}" | grep -nx "# 1:2345:respawn:/sbin/getty -noclear 38400 tty1" | sed -n 's/^\([0-9]*\)[:].*/\1/p'`;
		local linenumber_patched=`cat "${file_init}" | grep -nx "$line_init_replace" | sed -n 's/^\([0-9]*\)[:].*/\1/p'`;
		if [ ${linenumber_patched} == 72 ]; then
			echo "[franzisCAM] ${file_init} bereits gepatcht.";
		else
			echo "[franzisCAM] Unbekannter Fehler.";
			echo "[franzisCAM] Abbruch!";
		fi;
	fi;
	cp /home/pi/.bashrc /home/pi/.bashrc.bak;
	echo -e "\n if [ -z "$DISPLAY" ] && [ $(tty) == /dev/tty1 ]; then \n ./franziscam.sh &; \n fi" >> /home/pi/.bashrc;
	# Neustart notwendig?
	if [ $reboot_required == 1 ]; then
		echo "[franzisCAM] Datei ${file_init} wurde angepasst, damit der Patch aktiv wird, ist ein Neustart erforderlich.";
	fi;
}
#----------------------------------------------------------------------------------

 

#-------------------------------------------------------------------------
#
#  START
#
function init(){
	# gpio initialisieren
	gpio_init;
 	sudo killall -9 fb 2>/dev/null;
        sudo killall -9 omxplayer 2>/dev/null;
	if cd $FILE_PATH; then
		#mkdir -p $FILE_PATH;
		#cd $FILE_PATH
		clear;
		# check ob Kamera vorhanden
		check_raspicam;
		echo "--------------------------------------------------------------------------";
		echo "[franzisCAM] - Raspberry Pi franzisCAM v1 im Einsatz (Beenden mit: CTRL-C)";
		echo "--------------------------------------------------------------------------";
		zaehler_init;
		fbi_init;
		gpsd_init;
		raspivid_init;
		video_init;
	else
		error_exit "[franzisCAM] Kann nicht das Verzeichnis wechseln! Abbruch."
	fi;
}
#------------------------------------------------------------------------
function inc_myindex(){
	ZAEHLERAKTUELL=$myindexnumber
	if [ ! -z "$ZAEHLERAKTUELL" ]; then
		myindexnumber=`echo $ZAEHLERAKTUELL+1 | bc`;
   	else
		myindexnumber=0;
	fi
}
#-------------------------------------------------------------------------
function desc_myindex(){
	ZAEHLERAKTUELL=$myindexnumber
	if [ ! -z "$ZAEHLERAKTUELL" ]; then
		myindexnumber=`echo $ZAEHLERAKTUELL-1 | bc`;
   	else
		myindexnumber=0;
	fi
}
#-------------------------------------------------------------------------

#-------------------------------------------------------------------------
# start MAIN
init;

#------------ ende fuer debugzwecke ----------------------
while true; do
        if [ $(gpio -g read $GPIO_IMGR) -eq  0 ]; then
            echo "[franzisCAM] GPIO_IMGR" $GPIO_IMGR "gedrueckt";
            inc_switch SW_SHOW_IMGR $iSW_SHOW_IMGR;
            if [ "$iSW_SHOW_DEL" -eq 1 ]; then # Kommt aus DEL
            	echo "[franzisCAM] Delete-Button wurde zuvor gedrueckt";
            else
            	echo "[franzisCAM] Delete-Button wurde nicht vorher gedrueckt";
            	iSW_SHOW_DEL=0;
            fi;
            if [ "$iSW_SHOW_IMGR" -eq 1 ]; then # erster druck
            	if [ "$iSW_SHOW_IMGL" -eq 1 ]; then # vorher bereits "L" gedrueckt
            		echo "[franzisCAM] R-Button -> vorher L-Button gedrueckt";
            		echo "[franzisCAM] Erhoehe Zeiger um eins und zeige Datei";
            		# springe eine Datei weiter und zeige diese an
					getIndexNumberFirst;
					inc_myindex;
                    # echo "INDEX ist hier " $myindexnumber;
                    showImage;
            	else
            		# springe zu letzter Datei
            		# zeige letzte Aufnahme / Vorschaubild in Verzeichnis an
                    getIndexNumberLast;
                    # echo "INDEX ist hier " $myindexnumber;
                    showImage;
            		echo "[franzisCAM] R-Button -> kein vorheriges R/L-Event";
            		echo "[franzisCAM] Zeiger auf letzte Aufnahme und Anzeige";
            	fi;
            else
            	# springe an anfang in Verzeichnisliste &
            	# zeige erste Aufnahme / Vorschaubild in Verzeichnis an
            	echo "[franzisCAM] R-Button -> vorher R-Button gedrueckt, Zeiger auf naechste Aufnahme";
            	if [ "$iSW_SHOW_IMGR" -gt 1 ]; then
            		iSW_SHOW_IMGR=1;
                    #getIndexNumberFirst;
					inc_myindex;
					tmp_myindexnumber=$myindexnumber;
					getIndexNumberLast;
					max_myindexnumber=$myindexnumber;
					if [ "$tmp_myindexnumber" -ge "$max_myindexnumber" ]; then
						myindexnumber=0; # Springe an Anfang
					else
						myindexnumber=$tmp_myindexnumber;
					fi;
					# echo "INDEX ist hier " $myindexnumber;
					showImage;
            	fi;
            fi;
            iSW_SHOW_IMGL=0;
        elif [ $(gpio -g read $GPIO_IMGL) -eq  0 ]; then
            echo "[franzisCAM] GPIO_IMGL" $GPIO_IMGL "gedrueckt";
            inc_switch SW_SHOW_IMGL $iSW_SHOW_IMGL
            if [ "$iSW_SHOW_DEL" -eq 1 ]; then # Kommt aus DEL
                echo "[franzisCAM] Delete-Button wurde zuvor gedrueckt";
            else
            	echo "[franzisCAM] Delete-Button wurde nicht vorher gedrueckt";
                iSW_SHOW_DEL=0;
            fi;
            if [ "$iSW_SHOW_IMGL" -eq 1 ]; then # erster druck
            	if [ "$iSW_SHOW_IMGR" -eq 1 ]; then # vorher bereits "R" gedrueckt
            		echo "[franzisCAM] L-Button -> vorher R-Button gedrueckt";
            		echo "[franzisCAM] Erniedrige Zeiger um eins und zeige Datei";
            		# springe eine Datei zurueck und zeige diese an
                    	getIndexNumberLast;
			desc_myindex;
                    # echo "INDEX ist hier " $myindexnumber;
            	else
            		echo "[franzisCAM] L-Button -> kein vorheriges L/R-Event";
            		echo "[franzisCAM] Zeiger auf erste Aufnahme und Anzeige";
					#	myindexnumber = $(getIndexNumberFirst);
					#	myindexnumber =`getIndexNumberFirst`;
					getIndexNumberFirst;
					# echo "INDEX ist hier " $myindexnumber;
            		# springe zu erster Datei
            		# zeige erste Aufnahme / Vorschaubild in Verzeichnis an
            	fi;
				showImage;
            else
            	echo "[franzisCAM] L-Button -> vorher L-Button gedrueckt, Zeiger auf letzte Aufnahme";
            	# springe an Ende in Verzeichnisliste &
            	# zeige letzte Aufnahme / Vorschaubild in Verzeichnis an
            	if [ "$iSW_SHOW_IMGL" -gt 1 ]; then
            		iSW_SHOW_IMGL=1;
                fi;
                #getIndexNumberLast;
				desc_myindex;
				if [ "$myindexnumber" -le 0 ]; then 
					getIndexNumberLast;
				fi; 
                # echo "INDEX ist hier " $myindexnumber;
                showImage;
            fi;
            iSW_SHOW_IMGR=0;
        elif [ $(gpio -g read $GPIO_DEL) -eq  0 ]; then
            echo "[franzisCAM] GPIO_DEL" $GPIO_DEL "gedrueckt";
            inc_switch SW_SHOW_DEL $iSW_SHOW_DEL;
			#echo "iSW_SHOW_DEL = " $iSW_SHOW_DEL
            if [ "$iSW_SHOW_DEL" -eq 1 ]; then # erster druck
            	echo "[franzisCAM] DEL-Button -> Zeiger auf letzte Aufnahme";
            	# zeige letzte Bildaufnahme X an
            	inc_switch SW_SHOW_IMGR $iSW_SHOW_IMGR;
            	# springe zu letzter Datei
            	# zeige letzte Aufnahme / Vorschaubild in Verzeichnis an
                getIndexNumberLast;
                # echo "INDEX ist hier " $myindexnumber;
                showImage;
            else
            	echo "[franzisCAM] DEL-Button -> VORHER SCHON DEL-Button gedrueckt -> LOESCHEN";
            	# zweites Druecken -> dann angezeigte Datei loeschen
            	deleteImage;
            	# Status resetten
            	iSW_SHOW_DEL=0;
            	inc_switch SW_SHOW_IMGR $iSW_SHOW_IMGR;
            	# springe zu letzter Datei
                getIndexNumberLast;
                # echo "INDEX ist hier " $myindexnumber;
                showImage;
            fi;
            iSW_SHOW_IMGL=0;
            iSW_SHOW_IMGR=0;
       	elif [ $(gpio -g read $GPIO_SHUTTER) -eq  0 ]; then
            echo "[franzisCAM] GPIO_SHUTTER" $GPIO_SHUTTER "gedrueckt";
            inc_switch SW_SHUTTER $iSW_SHUTTER;
            iSW_SHOW_IMGL=0;
            iSW_SHOW_IMGR=0;
            takeSnapshot;
	    # zeige das Bild gleich an
	    getIndexNumberLast;
	    showImage;
        elif [ $(gpio -g read $GPIO_VIDEO) -eq  0 ]; then
            echo "[franzisCAM] GPIO_VIDEO" $GPIO_VIDEO "gedrueckt";
	#       SW_VIDEOD=1;
		if [ "$SW_VIDEOD" -eq 1 ]; then # Video-Funktionen sind aktiv
            		echo "[franzisCAM] Video-Funktionen aktiv.";
		        inc_switch SW_VIDEO $iSW_VIDEO;
	    	        iSW_SHOW_IMGL=0;
        		iSW_SHOW_IMGR=0;
			recordVideo;
			# nach Abschluss in MP4 konvertieren
			convert_h264_2_MP4;
		else
			#		SW_VIDEOD=0;
			echo "[franzisCAM] Video-Funktionen sind deaktiviert.";
			fi;
        fi;
sleep 0.1;
done

exit 0
# --------------------------- EOF ---------------------------------------
