#!/bin/bash
# ----------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016
# ----------------------------------------------------
# Funktion gps2pic.sh
# ----------------------------------------------------
LONGITUDE=`gpspipe -w -n 5 | grep lon | grep -i -m 1 tpv | cut -d ',' -f8 | cut -d ':' -f2`
LATITUDE=`gpspipe -w -n 5 | grep lat | grep -i -m 1 tpv | cut -d ',' -f7 | cut -d ':' -f2`
DATE_FILE=`date +%Y-%m-%d_%H-%M`
DATE_EXIF=`date +%Y:%m:%d`
TIME_EXIF=`date +%H:%M:%S`
FILE=mailpic.jpg
TXT="Skript gestartet"
# GPS angeschlossen?
if [ "$(ls /dev/ttyUSB0)" ]; then
        TXT="${TXT}  \nund GPS an Raspberry Pi angeschlossen"
        # CAM angeschlossen?
        if [ "$(ls /dev/video0)" ]; then
                TXT="${TXT}  \nund Videodevice an Raspberry Pi angeschlossen"
                /usr/bin/fswebcam -r 320x240 -i 0 -d /dev/video0 --jpeg 95 --shadow --title "RaspiCAR" --subtitle "CAM-Front" --info "Monitor: Active" -v $FILE
                echo Derzeitige GPS-Position: $LONGITUDE Laengengrad und $LATITUDE Breitengrad
                echo Es wird $FILE verarbeitet am $DATE_EXIF $TIME_EXIF
                if [ "$FILE" ]; then
                        exiftool -overwrite_original -xmp:dateTimeOriginal="$DATE_EXIF $TIME_EXIF" -GPSLongitudeRef=E -GPSLongitude=$LONGITUDE -GPSLatitudeRef=N -GPSLatitude=$LATITUDE $FILE -o $DATE_FILE$FILE
                else
                        TXT="${TXT} \n keine Datei vorhanden"
                fi
        else
                TXT="${TXT}  \nund kein Videodevice an Raspberry Pi angeschlossen"
        fi
else
        TXT="${TXT}  \nund kein GPS an Raspberry Pi angeschlossen"
        # CAM angeschlossen?
        if [ "$(ls /dev/video0)" ]; then
                TXT="${TXT}  \nund Videodevice an Raspberry Pi angeschlossen"
                /usr/bin/fswebcam -r 320x240 -i 0 -d /dev/video0 --jpeg 95 --shadow --title "RaspiCAR" --subtitle "CAM-Front" --info "Monitor: Active" -v $FILE
        else
                TXT="${TXT}  \nund kein Videodevice an Raspberry Pi angeschlossen"
        fi
fi
echo $TXT
