#!/usr/bin/env python
#-*- coding:utf-8 -*-
# ----------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016
#
# Datei gpsthief-step3.py
#
# Funktion Standortinformation
# installiertes geopy-0.95.1-Paket notwendig
#
import sys, os
import subprocess
import time
from geopy import geocoders
from geopy.geocoders import GoogleV3
from geopy import distance as geopy_dis
# ----------------------------------------------------
def abstand((x1, y1), (x2, y2), unit='km'):
   if (x1, y1) == (x2, y2):
       return 0
#   geopy_dis.distance = geopy_dis.GreatCircleDistance
# Vincenty inverse
   geopy_dis.VincentyDistance.ELLIPSOID = 'Intl 1924'
   d = geopy_dis.distance((x1, y1), (x2, y2))
   if unit == 'miles':
       return d.miles
   else:
       return d.kilometers
# ----------------------------------------------------
def cmd_exists(cmd):
    return subprocess.call("type " + cmd, shell=True,
        stdout=subprocess.PIPE, stderr=subprocess.PIPE) == 0
# ----------------------------------------------------
def main():
  os.system('clear')
  delay=10
  GPSPIPE="/usr/bin/gpspipe"
  home_latitude="48.11389"
  home_longitude="11.73283"
  home_zone_m="5000" # 50 Kilometer
  home_zone_km=str(int(home_zone_m)/1000)
  print "[GPS] Check ob ", GPSPIPE ," vorhanden..."
  if cmd_exists(GPSPIPE):
    # "vorhanden "
    print "[GPS] Koordinaten..."
    g = geocoders.GoogleV3()
    try:
       while True:
          LONGITUDE="gpspipe -w -n 5 | grep lon | grep -i -m 1 tpv | cut -d ',' -f8 | cut -d ':' -f2"
          LATITUDE="gpspipe -w -n 5 | grep lat | grep -i -m 1 tpv | cut -d ',' -f7 | cut -d ':' -f2"
          os.system('clear')
          print "[GPS] Koordinaten..."
          longitude=os.popen(LONGITUDE).read()
          longitude=longitude.strip()
          latitude=os.popen(LATITUDE).read()
          latitude=latitude.strip()
          print "| Breitengrad (Homel): ", home_latitude
          print "| Laengengrad (Homel): ", home_longitude          placehome = g.reverse(home_latitude+","+home_longitude,exactly_one=True)
          print "| Home: ", placehome
          print "| Breitengrad (aktuell): ", latitude
          print "| Laengengrad (aktuell): ", longitude
          google ="| Google Maps: https://maps.google.com/maps?q="
          google=google+latitude+","+longitude
          print google
          placenow = g.reverse(latitude+","+longitude,exactly_one=True) # nur 1ter Treffer in Location-Liste
          print "| Aktueller Ort: ", placenow
          print "|"
          distanceMeter = abstand((home_latitude,home_longitude), (latitude,longitude))
          print "| Abstand zwischen \n|    ", placehome, "\n| und \n|    ", placenow, "\n|\n| betraegt:  ", distanceMeter, " km"
          if distanceMeter > int(home_zone_km):
             print "|"
             print "| Alarm: Zulaessige Entfernung von ", int(home_zone_km) ,  "km wurde um ", round(distanceMeter-int(home_zone_km),3),  "km ueberschritten"
          else:
             print "|"
             print "| Alles OK"
          print "|___________________________________________________________________________"
          time.sleep(delay)
    except KeyboardInterrupt:
       sys.exit(0)
  else:
     print "[GPS] ",GPSPIPE , "nicht vorhanden.."
     # gpspipe ist in Paket gpsd-clients
     os.system('sudo apt-get install gpsd gpsd-clients -y')
     print "[GPS] ",GPSPIPE , "wurde nachinstalliert... Bitte Programm neu starten..."
# ---------------------------------------------------------------------
if __name__ == '__main__':
  main()
# ------------------------------------- EOF ---------------------------
