# -*- coding: utf-8 -*- 
#!/bin/python 
import RPi.GPIO as GPIO 
import time, os
#  ---------------------------------------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016
# Datei mcp3008-step1.py
#  ---------------------------------------------------------------------------------
GPIO.setmode(GPIO.BCM) #  GPIO Mode
#  ---------------------------------------------------------------------------------
# Konfiguration Eingangskanal und GPIOs
poti_channel = 0  # Analog/Digital-Kanal 0
CLK_Pin = 11 # Clock -> Pin 13 / GPIO11 / SPI0_SCLK/ Pin 23 / wiringPi = 14
DIN_Pin = 10 # Digital in -> Pin 11 / GPIO10 / SPI MOSI / Pi Pin 19 / wiringPi = 12
DOUT_Pin = 9 # Digital out -> Pin 12 / GPIO9 / SPI MISO / Pin 21 / wiringPi = 13
CS_Pin = 8 # Cable-Select -> Pin 10 / GPIO8 / SPI0_CE0_N / Pin 24 / wiringPi = 10
#  ---------------------------------------------------------------------------------
# GPIO konfigurieren
GPIO.setup(CLK_Pin, GPIO.OUT)
GPIO.setup(DIN_Pin, GPIO.OUT)
GPIO.setup(DOUT_Pin, GPIO.IN)
GPIO.setup(CS_Pin, GPIO.OUT)
# ---------------------------------------------------------------------------------
# Funktionen 
#
def getAnalogData(poti_channel, CLK_Pin, DIN_Pin, DOUT_Pin, CS_Pin):
    # Pegel definieren
    GPIO.output(CS_Pin, True)
    GPIO.output(CS_Pin, False)
    GPIO.output(CLK_Pin, False)
    pushcmd = poti_channel
    pushcmd |= 0b00011000 # = 0x18 (1:Startbit, 1:Single/ended) 
                      #  Kommando zum Werte-Abruf des Kanals
    # Bitfolge senden
    for i in range(5):
	GPIO.output(DIN_Pin, bool(pushcmd & 0b10000))
        # Clocksignal negative Flanke erzeugen
        GPIO.output(CLK_Pin, True)
        GPIO.output(CLK_Pin, False)
        pushcmd <<= 1 # Bitfolge eine Position nach links verschieben
    # Daten holen
    poti_channel_value = 0 # Wert auf 0 reseten
    for i in range(11):
        GPIO.output(CLK_Pin, True)
        GPIO.output(CLK_Pin, False)
        poti_channel_value <<= 1 # Um eins nach links schieben
        if(GPIO.input(DOUT_Pin)):
            poti_channel_value |= 0x01
    time.sleep(0.5)
    return poti_channel_value

# ----------------------------------------------
# Start Python-Skript
# ----------------------------------------------
os.system('clear')
print "[mcp3008] Messung Drehpotentiometer"
anz=3
# Drei hintereinanderfolgende Messungen werden gemittelt (anz)
try:
  while True:
    sum=0
    for i in range(anz):
    	tmp = getAnalogData(poti_channel, CLK_Pin, DIN_Pin, DOUT_Pin, CS_Pin)
        sum=(sum+tmp)
        print "Summe =", sum
	time.sleep(0.15)
    tmp_value = sum / anz
    print "Wert Kanal Nr.", poti_channel, "=", tmp_value
    time.sleep(2) # Sekunden warten
except KeyboardInterrupt:
  # CTRL-C gedrueckt
  # Reset GPIO
  print "[mcp3008] Messung abgebrochen."
  GPIO.cleanup()
# ------------------- EOF  -----------------------

