# -*- coding: utf-8 -*-
#!/usr/bin/python
# -----------------------------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016/2917
# -----------------------------------------------------------------------
# Funktion motorledcam.py fuer polulu-Stepperplatine
#
import RPi.GPIO as GPIO
import time
#
# Funktion ledblinken
# Einschalten / 2 Sekunden / Ausschalten / 2 Sekunden
#
def ledblinken(raspipin, sec):
        GPIO.output(raspipin,GPIO.HIGH)
        time.sleep(sec)
        GPIO.output(raspipin,GPIO.LOW)
        time.sleep(sec)
        return

def focus(focus_pin):
        GPIO.output(focus_pin,GPIO.HIGH)
        time.sleep(sec)
        GPIO.output(focus_pin,GPIO.LOW)
        time.sleep(sec)
        return

def foto(shutter_pin):
        GPIO.output(shutter_pin,GPIO.HIGH)
        time.sleep(1.0)
        GPIO.output(shutter_pin,GPIO.LOW)
        print "-----------------------"
        print "|      FOTO            |"
        print "-----------------------"
        return

def setup(dir_pin, stepper_pin, shutter_pin, focus_pin):
        #
        # Hier wird die PIN-Nummerierung des Raspberry Pi verwendet
        # und NICHT die GPIO-Nummerierung
        #
        GPIO.setmode(GPIO.BOARD)
        # Definition der Pins im Boardmode . hier Pin 16 = GPIO23 = DIR
        #                                         Pin 18 = GPIO24 = STEP
        # ------------------------------------------------------------------
        #                                         Pin 12 = GPIO18 = SHUTTER
        #                                         Pin 11 = GPIO17 = FOCUS
        # ------------------------------------------------------------------
        # Optional bei "Feinsteuerung der Schrittweite" -> def initmsstep
        #                                         Pin 19 = GPIO10 = MS1
        #                                         Pin 21 = GPIO9 = MS2
        #                                         Pin 22 = GPIO25 = MS3
        # ------------------------------------------------------------------
        GPIO.setup(dir_pin, GPIO.OUT)
        GPIO.setup(stepper_pin, GPIO.OUT)
        GPIO.setup(shutter_pin, GPIO.OUT)
        GPIO.setup(focus_pin, GPIO.OUT)
        GPIO.setup(ms1_pin, GPIO.OUT)
        GPIO.setup(ms2_pin, GPIO.OUT)
        GPIO.setup(ms3_pin, GPIO.OUT)
        print "dir_pin auf ", dir_pin, " gesetzt"
        print "stepper_pin auf ", stepper_pin, " gesetzt"
        print "shutter_pin auf ", shutter_pin, " gesetzt"
        print "focus_pin auf ", focus_pin, " gesetzt"
        return

def initmsstep(ms1_pin_wert, ms2_pin_wert, ms3_pin_wert):
        if ms1_pin_wert == 1:
                GPIO.output(ms1_pin,GPIO.HIGH)
                print " ms1_pin (", ms1_pin ,") auf HIGH"
                if ms2_pin_wert == 1:
                        GPIO.output(ms2_pin,GPIO.HIGH)
                        print " ms2_pin (",ms2_pin ,") auf HIGH"
                        if ms3_pin_wert == 1:
                                GPIO.output(ms3_pin,GPIO.HIGH)
                                print " ms3_pin (",ms3_pin ,") auf HIGH"
                                print "Konfiguration: Sechzehntelschritt"
                        else:
                                GPIO.output(ms3_pin,GPIO.LOW)
                                print " ms3_pin (", ms3_pin ,") auf LOW"
                                print "Konfiguration: Achtelschritt"
                else:
                        GPIO.output(ms2_pin,GPIO.LOW)
                        print " ms2_pin (", ms2_pin ,") auf LOW"
                        if ms3_pin_wert == 1:
                                # GPIO.output(ms3_pin,GPIO.HIGH)
                                print " ms3_pin (",ms3_pin ,") auf HIGH"
                                print "Konfiguration 1-0-1: Nicht Definiert!"
                                print "changed in 1-0-0: Halbschritt!"
                                GPIO.output(ms3_pin,GPIO.LOW)
                        else:
                                GPIO.output(ms3_pin,GPIO.LOW)
                                print " ms3_pin (", ms3_pin ,") auf LOW"
                                print "Konfiguration: Halbschritt"
        else:
                GPIO.output(ms1_pin,GPIO.LOW)
                print " ms1_pin (", ms1_pin ,") auf LOW"
                if ms2_pin_wert == 1:
                        GPIO.output(ms2_pin,GPIO.HIGH)
                        print " ms2_pin (",ms2_pin ,") auf HIGH"
                        if ms3_pin_wert == 1:
                                # GPIO.output(ms3_pin,GPIO.HIGH)
                                print " ms3_pin (",ms3_pin ,") auf HIGH"
                                print "Konfiguration 0-1-1: Nicht Definiert!"
                                print "changed in 0-1-0: Viertelschritt!"
                                GPIO.output(ms3_pin,GPIO.LOW)
                        else:
                                GPIO.output(ms3_pin,GPIO.LOW)
                                print " ms3_pin (", ms3_pin ,") auf LOW"
                                print "Konfiguration: Viertelschritt"
                else:
                        GPIO.output(ms2_pin,GPIO.LOW)
                        print " ms2_pin (", ms2_pin ,") auf LOW"
                        if ms3_pin_wert == 1:
                                print " ms3_pin (",ms3_pin ,") auf HIGH"
                                # GPIO.output(ms3_pin,GPIO.HIGH)
                                print "Konfiguration 0-0-1: Nicht Definiert!"
                                print "changed in 0-0-0: Vollschritt!"
                                GPIO.output(ms3_pin,GPIO.LOW)
                        else:
                                GPIO.output(ms3_pin,GPIO.LOW)
                                print " ms3_pin (", ms3_pin ,") auf LOW"
                                print "Konfiguration: Vollschritt"
        return

def step(d_pin, s_pin, dir, steps):
        if dir == 1:
                GPIO.output(d_pin,GPIO.HIGH)
                print "dir_pin (23) auf HIGH"
        else:
                GPIO.output(d_pin,GPIO.LOW)
                print "dir_pin (23) auf LOW"
        for i in range (0,steps):
                print "In for Schleife bei : ", i, " von ", steps, " Steps"
                GPIO.output(s_pin,GPIO.HIGH)
                print "Setze stepper_pin auf HIGH - dir_pin ist auf: ", d_pin, "Richtung : ", dir
                GPIO.output(s_pin,GPIO.LOW)
                print "Setze stepper_pin auf LOW - dir_pin ist auf: ", d_pin, "Richtung : ", dir
        print "Durchgang erledigt"
        print "-------------------------------------------------------------"
        return
def sliderphoto(shutter_pin, anzahl, abstand, dir_pin, stepper_pin, richtung, focus_pin):
        for i in range (0, anzahl):
                # foto ausloesen
                focus(focus_pin)
                foto(shutter_pin)
                print "Foto", "Nr.", i+1 , "von :", anzahl
                print "--------------------------------"
                time.sleep(2)
                # der wert 1154 ist ggf. auf ihre konfiguration anzupassen
                steps = int (1154 * abstand)
                step(dir_pin, stepper_pin, richtung, steps)
                print "dir_pin, stepper_pin, richtung, steps"
                print dir_pin, stepper_pin, richtung, steps
                time.sleep(3)
        # fertig - nun wieder aufraeumen
        if richtung == 1:
                richtung = 0
        else:
                richtung = 1
        # kamera wieder in ausgangsposition
        print "Aufraeumen-> dir_pin, stepper_pin, richtung, steps"
        print dir_pin, stepper_pin, richtung, steps*anzahl
        step(dir_pin, stepper_pin, richtung, steps*anzahl)
        return

# -------------------------------------------------------------------------------------
# Definitionen
# -------------------------------------------------------------------------------------
dir_pin = 16
stepper_pin = 18
shutter_pin = 12
focus_pin = 11
ms1_pin = 19
ms2_pin = 21
ms3_pin = 22
# -------------------------------------------------------------------------------------
# initialisieren
setup(dir_pin, stepper_pin, shutter_pin, focus_pin)
initmsstep(0,0,0)
# (ms1_pin_wert, ms2_pin_wert, ms3_pin_wert)
# hierbei:
# MS1-MS2-MS3-Umdrehung
# 1, 0, 0 = High-Low-Low = Halbschritt
# 0, 1, 0 = Low-High-Low = Viertelschritt
# 1, 1, 0 = High-High-Low = Achtelschritt
# 1, 1, 1 = High-High-High = Sechzehntelschritt
# 0, 0, 0 = Low-Low-Low = Vollschritt
# -------------------------------------------------------------------------------------
#  Dreh-Richtung einstellen
# 
# 1 = links - kameraslider zurueck
# 0 = rechts - kameraslider vorwaerts
richtung = 1
# fuer Test-> steps = 5770
# 5770 = 50mm
# => 10mm = 1154 Steps
#step(dir_pin, stepper_pin, richtung, steps)
# anzahl Aufnahmen
anzahl = 10
# Abstand zwischen Aufnahmen in cm, hier 2 mm
abstand = 0.2
sec = 0.2
# -------------------------------------------------------------------------------------
# aufruf slider
sliderphoto(shutter_pin, anzahl, abstand, dir_pin, stepper_pin, richtung, focus_pin)
# --------------------------------------------------------------------------------------
#  Fertig -> Aufrauemen
GPIO.cleanup()
# ------------------------------ EOF ---------------------------------------------------
