#!/usr/bin/python
# -----------------------------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016/2917
# -----------------------------------------------------------------------
# Funktion uln_linksrechts.py fuer uln2803-Schaltung bei 
# unipolaren Steppermotoren
#
import RPi.GPIO as gpio
import time
# -----------------------------------------------------------------------
# Hier anpassen: GPIO Pins fuer den Motor
a0=15
a1=18
b0=22
b1=17
# -----------------------------------------------------------------------
motor_pins = [a0,b0,a1,b1]
links = [(a0,),(a0,b0),(b0,),(b0,a1),(a1,),(a1,b1),(b1,),(b1,a0)]
rechts = [(b1,),(b1,a1),(a1,),(a1,b0),(b0,),(b0,a0),(a0,),(a0,b1)]
# Delay beim "Lauf"
wait = 0.002
# -----------------------------------------------------------------------
# GPIOs initialisieren
gpio.setmode(gpio.BCM)
for s_pin in motor_pins:
    gpio.setup(s_pin, gpio.OUT)
# -----------------------------------------------------------------------
# Funktion step fuer die Durchfuehrung des Schritts...
def step(seq, m_pins):
    for steps in seq:
        for s_pin in m_pins:
            gpio.output(s_pin, gpio.HIGH) if s_pin in steps else gpio.output(s_pin, gpio.LOW)
        time.sleep(wait)
# -----------------------------------------------------------------------
# Drehe solange bis Abbruch via Tastatur <strg><c>
try:
    while True:
        for _ in xrange(256):
            step(links,motor_pins)  # links
        for _ in xrange(128):
            step(rechts,motor_pins)  # rechts
except KeyboardInterrupt:
    gpio.cleanup()
# --------------------------- EOF --------------------------------------