#!/usr/bin/python
# -*- coding: utf-8 -*-
# ------------------------------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016
# ------------------------------------------------------------------------
# pi_publishmqtt_dht11.py
# ------------------------------------------------------------------------
import re, os, time
import paho.mqtt.client as mqtt
import Adafruit_DHT
#
GPIOpin = 4
#
localserver = "192.168.123.45"
topic = "iot/event/status/fmt/json"
#
def on_connect(client, userdata, flags, rc):
   print("Connected with "+localserver +"\n\nresult code : "+str(rc))
# ----------------------------------------------------
def start_mqtt():
   # client = mqtt.Client()
   client.on_connect = on_connect
   client.connect(localserver, 1883, 60)
   print "Verbindung zu "+localserver+" erfolgt..."
# ----------------------------------------------------
def buildJson():
  humidity, temperature = Adafruit_DHT.read_retry( Adafruit_DHT.DHT11, GPIOpin )
  if (humidity is not None and temperature is not None):
#    print "Temp={0:f}*C  Humidity={1:f}%".format(temperature, humidity)
    tempDHT = str(temperature)
    humiDHT = str(humidity)
  else:
    tempDHT = "0"
    humiDHT = "0"
  data= ""
  "{".join(data)
  data+="\n"
  data+= "\"d\": {"
  data+="\n"
  data+="\"iotName\": \"Raspberry Pi DHT11\","
  data+="\n"
  data+="\"temperature (C)\": "
  data+=tempDHT
  data+=","
  data+="\n"
  data+="\"humidity\": "
  data+=humiDHT
  data+="\n"
  data+="}"
  return data
# ----------------------------------------------------
# schreibe daten in mqtt-json
client = mqtt.Client()
start_mqtt()
while True:
  # read sensor data
  print buildJson()
  client.publish(topic, buildJson())
  time.sleep(10)
