#!/bin/bash
# ----------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016/2017
# ----------------------------------------------------
# Definitionen
#-------------------------------------------------------------------------
# Datei noise-step1.sh
# GPIO
GPIO_SOUND=7 # pin 26 - wiring pi 11
#
function gpio_init(){
        gpio_export $GPIO_SOUND;
        gpio_configure_input $GPIO_SOUND;
}
#-------------------------------------------------------------------------
function gpio_configure_output() {
        if [ -e "/sys/class/gpio/gpio${1}/direction" ]; then
                echo "out" > "/sys/class/gpio/gpio${1}/direction";
        fi
}
#-------------------------------------------------------------------------
function gpio_configure_input() {
        if [ -e "/sys/class/gpio/gpio${1}/direction" ]; then
                echo "in" > "/sys/class/gpio/gpio${1}/direction";
        fi
}
#-------------------------------------------------------------------------
function gpio_export() {
        echo -n "exporting gpio $1"
        if [ -e "/sys/class/gpio/gpio${1}/" ]; then
                echo "...gpio${1} already exists";
        else
                echo
                echo "${1}" > "/sys/class/gpio/export";
        fi
}
#-------------------------------------------------------------------------
function gpio_unexport() {
        echo -n "unexporting gpio $1";
        if [ -e "/sys/class/gpio/gpio${1}/" ]; then
                echo
                echo "${1}" > "/sys/class/gpio/unexport";
        else
                echo "-> gpio${1} does not exist";
        fi
}
#-------------------------------------------------------------------------
function inc_zaehler(){
        local ZAEHLERAKTUELL=$myindexnumber
        if [ ! -z "$ZAEHLERAKTUELL" ]; then
                myindexnumber=`echo $ZAEHLERAKTUELL+1 | bc`;
        else
                myindexnumber=0;
        fi
}
#-------------------------------------------------------------------------
function zaehler_init(){
        if [ -e  "/usr/bin/bc" ]; then
                echo -e "\n\n[soundCAM] OK, bc bereits installiert";
        else
        echo -e "\n\n[soundCAM] kein bc installiert, wird nachgeholt..";
                sudo apt-get install bc -y;
        fi
}
#-------------------------------------------------------------------------
#  START
#
function init(){
        # gpio initialisieren
        zaehler_init;
        gpio_init;
}
#-------------------------------------------------------------------------
# start MAIN
init;
clear;
echo "[soundCAM] Es wird gelauscht...";
myindexnumber=0;
# GPIO ist auf high
# bei Geraeusch dann auf LOW - 0
while true; do
        if [ $(gpio -g read $GPIO_SOUND) -eq  0 ]; then
                echo "[soundCAM] Geraeusch Nr.= "  $myindexnumber;
                inc_zaehler;
        fi;
#       echo "[soundCAM] WERT: "$(gpio -g read $GPIO_SOUND);
sleep 0.1;
done;
exit 0;
#--------------------------- EOF -------------------------------------------------------------
