#!/bin/bash
# ----------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016/2017
#-------------------------------------------------------------------------
# Definitionen
#-------------------------------------------------------------------------
# Datei noise-step2.sh
# GPIO
GPIO_SOUND=7; 	# pin 26 - wiring pi 11 - EINGANG
GPIO_SHUTTER=25; 	# Pin 22 = GPIO25 = GPIO_SHUTTER - AUSGANG
GPIO_FOCUS=9; 	# Pin 21 = GPIO9 = GPIO_FOCUS - AUSGANG
#
function gpio_init(){
        gpio_export $GPIO_SOUND;
        gpio_configure_input $GPIO_SOUND;
		
		gpio_export $GPIO_SHUTTER;
        gpio_configure_output $GPIO_SHUTTER;
						
		gpio_export $GPIO_FOCUS;
        gpio_configure_output $GPIO_FOCUS;
}
#-------------------------------------------------------------------------
function gpio_configure_output() {
        if [ -e "/sys/class/gpio/gpio${1}/direction" ]; then
                echo "out" > "/sys/class/gpio/gpio${1}/direction";
        fi
}
#-------------------------------------------------------------------------
function gpio_configure_input() {
        if [ -e "/sys/class/gpio/gpio${1}/direction" ]; then
                echo "in" > "/sys/class/gpio/gpio${1}/direction";
        fi
}
#-------------------------------------------------------------------------
function gpio_export() {
        echo -n "exporting gpio $1"
        if [ -e "/sys/class/gpio/gpio${1}/" ]; then
                echo "...gpio${1} already exists";
        else
                echo
                echo "${1}" > "/sys/class/gpio/export";
        fi
}
#-------------------------------------------------------------------------
function gpio_unexport() {
        echo -n "unexporting gpio $1";
        if [ -e "/sys/class/gpio/gpio${1}/" ]; then
                echo
                echo "${1}" > "/sys/class/gpio/unexport";
        else
                echo "-> gpio${1} does not exist";
        fi
}
#-------------------------------------------------------------------------
function inc_zaehler(){
        local ZAEHLERAKTUELL=$myindexnumber
        if [ ! -z "$ZAEHLERAKTUELL" ]; then
                myindexnumber=`echo $ZAEHLERAKTUELL+1 | bc`;
        else
                myindexnumber=0;
        fi
}
#-------------------------------------------------------------------------
function zaehler_init(){
        if [ -e  "/usr/bin/bc" ]; then
                echo -e "\n\n[soundCAM] OK, bc bereits installiert";
        else
        echo -e "\n\n[soundCAM] kein bc installiert, wird nachgeholt..";
                sudo apt-get install bc -y;
        fi
}
#-------------------------------------------------------------------------
function takeSnapshotGPIO() {
		# FOCUSIEREN
		gpio -g write $GPIO_FOCUS 1;
		sleep 0.1;
		gpio write $GPIO_FOCUS 0;
		# AUSLOESEN
		# ggf. zusaetzliche Wartezeit vor Ausloeser einbauen 
		# sleep 0.3;
		gpio -g write $GPIO_SHUTTER 1;
		sleep 0.2;
		gpio write $GPIO_SHUTTER 0;
		echo "[soundCAM] Aufnahme:" ${1} " wurde angefertigt.";
}
#-------------------------------------------------------------------------
#  START
#
function init(){
        # gpio initialisieren
        zaehler_init;
        gpio_init;
}
#-------------------------------------------------------------------------
# start MAIN
init;
clear;
echo "[soundCAM] Es wird gelauscht...";
myindexnumber=0;
# GPIO ist auf high
# bei Geraeusch dann auf LOW - 0
while true; do
        if [ $(gpio -g read $GPIO_SOUND) -eq  0 ]; then
                echo "[soundCAM] Geraeusch Nr.= "  $myindexnumber;
				takeSnapshotGPIO $myindexnumber; 
                inc_zaehler;
        fi;
#       echo "[soundCAM] WERT: "$(gpio -g read $GPIO_SOUND);
sleep 0.1;
done;
exit 0;
#--------------------------- EOF -------------------------------------------------------------
