#!/usr/bin/env python
# -*- coding: utf-8 -*-
# ---------------------------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016
# ---------------------------------------------------------------------
# Datei colorchecker01.py
#
import cv2, os
import numpy as np
import time
cap = cv2.VideoCapture(0)

lower_blue = np.array([85, 30, 5], dtype=np.uint8)
upper_blue = np.array([220, 88, 50], dtype=np.uint8)
#  minimum und max value blue pixel in BGR 
lower_white = np.array([0,0,0], dtype=np.uint8)
upper_white = np.array([0,0,255], dtype=np.uint8)
#
lower_red = np.array([17,15,100], dtype=np.uint8)
upper_red = np.array([50,56,200], dtype=np.uint8)
#
lower_yellow = np.array([25,146,190], dtype=np.uint8)
upper_yellow = np.array([61,175,251], dtype=np.uint8)
#
lower_grey = np.array([103,86,67], dtype=np.uint8)
upper_grey = np.array([144,134,127], dtype=np.uint8)
#
col_name  = ["blue","white","red","yellow","grey"]
col_lower = [lower_blue, lower_white, lower_red, lower_yellow, lower_grey]
col_upper = [upper_blue, upper_white, upper_red, upper_yellow, upper_grey]
col_pixel = [0,0,0,0,0]
#
while(1):
    _, frame = cap.read()
    # 0.2 # 200 ms sec warten
    time.sleep(.5) #  5 sec warten
    os.system("clear")
    max = col_pixel[0]
    i = 0
    col_nr = 0
    print("Anzahl Pixel......")
    while i < len(col_name):
       no = cv2.countNonZero(cv2.inRange(frame, col_lower[i],col_upper[i]))
       col_pixel[i] = int(no)
       print("              "+ col_name[i] + " : "  + str(no))
       if col_pixel[i] > max:
          max = col_pixel[i]
          col_nr = i
       i = i + 1
    print('\nFarbe '+ col_name[col_nr]+' = nr.: ' + str(col_nr) + ' -> Pixel max. : ' + str(max))
    cv2.imshow('Pi Live-Leak',frame)
    k = cv2.waitKey(5) & 0xFF
    if k == 27:
       break
cv2.destroyAllWindows()
# ------------------------------------------------------------------------------------------------
