#!/usr/bin/env python
# -*- coding: utf-8 -*-
# ---------------------------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016
# ---------------------------------------------------------------------
# Datei colorchecker02.py
#
from picamera.array import PiRGBArray
from picamera import PiCamera
import time
import cv2, os
import numpy as np

camera = PiCamera()
camera.resolution = (640, 480)
camera.framerate = 32
rawCapture = PiRGBArray(camera, size=(640, 480))
# kurz auf Kamera warten 
time.sleep(0.1)
lower_blue = np.array([85, 30, 5], dtype=np.uint8)
upper_blue = np.array([220, 88, 50], dtype=np.uint8)
#  minimum und max value blue pixel in BGR 
lower_white = np.array([0,0,0], dtype=np.uint8)
upper_white = np.array([0,0,255], dtype=np.uint8)
#
lower_red = np.array([17,15,100], dtype=np.uint8)
upper_red = np.array([50,56,200], dtype=np.uint8)
#
lower_yellow = np.array([25,146,190], dtype=np.uint8)
upper_yellow = np.array([61,175,251], dtype=np.uint8)
#
lower_grey = np.array([103,86,67], dtype=np.uint8)
upper_grey = np.array([144,134,127], dtype=np.uint8)
#
col_name  = ["blue","white","red","yellow","grey"]
col_lower = [lower_blue, lower_white, lower_red, lower_yellow, lower_grey]
col_upper = [upper_blue, upper_white, upper_red, upper_yellow, upper_grey]
col_pixel = [0,0,0,0,0]
#
for frame in camera.capture_continuous(rawCapture, format="bgr", use_video_port=True):
   time.sleep(.5) #  5 sec warten
   os.system("clear")
   max = col_pixel[0]
   i = 0
   col_nr = 0

   image = frame.array
   cv2.imshow("Pi Live-leak", image)
   print("Anzahl Pixel......")
   while i < len(col_name):
      no = cv2.countNonZero(cv2.inRange(image, col_lower[i],col_upper[i]))
      col_pixel[i] = int(no)
      print("              "+ col_name[i] + " : "  + str(no))
      if col_pixel[i] > max:
         max = col_pixel[i]
         col_nr = i
      i = i + 1
   print('\nFarbe '+ col_name[col_nr]+' = nr.: ' + str(col_nr) + ' -> Pixel max. : ' + str(max))
   rawCapture.truncate(0)
   k = cv2.waitKey(5) & 0xFF
   if k == 27:
      break
cv2.destroyAllWindows()
# ------------------------------------------------------------------------------------------------
