#!/usr/bin/env python
# -*- coding: utf-8 -*-
# ---------------------------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016
# ---------------------------------------------------------------------
# piopencv_apfel_step02.py

import cv2
# Bild aus aktuellen Verzeichnis laden
image = cv2.imread("beispieldatei.jpg", 1)
# Beschreibungsdatei laden
appleCascade = cv2.CascadeClassifier('haarcascade_apple.xml')
# Grauwerttrasformation
gray = cv2.cvtColor(image,cv2.COLOR_BGR2GRAY)
# Nach Apfel mit der Beschreibungsdatei in der Image Datei suchen
apple = appleCascade.detectMultiScale(gray,
        scaleFactor=1.1,
        minNeighbors=5,
        minSize=(30, 30),
        flags=cv2.CASCADE_SCALE_IMAGE
)

print "Es wurde(n)  "+str(len(apple))+" Apfel gefunden.\nDas Ergebnis wurde in Datei <apfel.jpg> gesichert.\n"
# Rechteck um jeden gefundenen Apfel zeichnen
for (x,y,w,h) in apple:
    cv2.rectangle(image,(x,y),(x+w,y+h),(0,0,255),3)
# Bild speichern
cv2.imwrite('apfel.jpg',image)
# Bild darstellen
cv2.imshow("img", image)
# abbruch mit q 
if cv2.waitKey(1) & 0xFF == ord('q'):
   break
   # fenster schliesen
   cv2.destroyAllWindows()