#!/usr/bin/python 
# -*- coding: utf-8 -*- 
# ----------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016
# ----------------------------------------------------
# Datei: pygame-step4.py
#
# schritt 4: Einbinden Grafik und Ausgabe der Nummer beim Klicken darauf
#
import pygame, sys, os, time
from pygame.locals import *
# Init PyGame
pygame.init()
FPS = 30 # frames per second 
fpsClock = pygame.time.Clock()
screen = pygame.display.set_mode((240, 320), 0, 32) # 320x240
pygame.display.set_caption('PyGame: Schritt 4')
# Farben definieren nach RGB-Schema
BLACK=(0,0,0)
WHITE=(255,255,255)
RED=(255,0,0)
BLUE=(0,0,255)
FUCHSIA=(255,0,255)
# Hintergrund aufbauen
background = pygame.Surface(screen.get_size())
#
ICONSPATH="icons/"

icon_x = 50
icon_y = 50
start_x = 10
start_y = 10
distance_x = 5
distance_y = 5
#
def set_background():
  global background
  background = background.convert()
  background.fill(BLACK)
  return;

def set_icons():
  Img_0 = pygame.image.load(ICONSPATH+'vu000.png')
  x_0 = start_x
  y_0 = start_y
  background.blit(Img_0, (x_0, y_0))
  Img_1 = pygame.image.load(ICONSPATH+'vu001.png')
  x_1 = x_0 + (icon_x + distance_x)
  y_1 = y_0
  background.blit(Img_1, (x_1, y_1))
  Img_2 = pygame.image.load(ICONSPATH+'vu002.png')
  x_2 = x_0 + 2 * (icon_x + distance_x)
  y_2 = y_0
  background.blit(Img_2, (x_2, y_2))
  # ---------------------
  Img_3 = pygame.image.load(ICONSPATH+'vu003.png')
  x_3 = x_0
  y_3 = y_0 + (icon_y + distance_y)
  background.blit(Img_3, (x_3, y_3))
  Img_4 = pygame.image.load(ICONSPATH+'vu004.png')
  x_4 = x_1
  y_4 = y_3
  background.blit(Img_4, (x_4, y_4))
  Img_5 = pygame.image.load(ICONSPATH+'vu005.png')
  x_5 = x_2
  y_5 = y_3
  background.blit(Img_5, (x_5, y_5))
  # ---------------------
  Img_6 = pygame.image.load(ICONSPATH+'vu006.png')
  x_6 = x_0
  y_6 = y_0 + 2 * (icon_y + distance_y)
  background.blit(Img_6, (x_6, y_6))
  Img_7 = pygame.image.load(ICONSPATH+'vu007.png')
  x_7 = x_1
  y_7 = y_6
  background.blit(Img_7, (x_7, y_7))
  Img_8 = pygame.image.load(ICONSPATH+'vu008.png')
  x_8 = x_2
  y_8 = y_6
  background.blit(Img_8, (x_8, y_8))
  # ---------------------
  Img_9 = pygame.image.load(ICONSPATH+'vu009.png')
  x_9 = x_0
  y_9 = y_0 + 3 * (icon_y + distance_y)
  background.blit(Img_9, (x_9, y_9))
  Img_10 = pygame.image.load(ICONSPATH+'vu010.png')
  x_10 = x_1
  y_10 = y_9
  background.blit(Img_10, (x_10, y_10))
  Img_11 = pygame.image.load(ICONSPATH+'vu011.png')
  x_11 = x_2
  y_11 = y_9
  background.blit(Img_11, (x_11, y_11))
  # ---------------------
  Img_12 = pygame.image.load(ICONSPATH+'vu012.png')
  x_12 = x_0
  y_12 = y_0 + 4 * (icon_y + distance_y)
  background.blit(Img_12, (x_12, y_12))
  Img_13 = pygame.image.load(ICONSPATH+'vu013.png')
  x_13 = x_1
  y_13 = y_12
  background.blit(Img_13, (x_13, y_13))
  Img_14 = pygame.image.load(ICONSPATH+'vu014.png')
  x_14 = x_2
  y_14 = y_12
  background.blit(Img_14, (x_14, y_14))
  return;

set_background()
set_icons()
# Textanzeige
font=pygame.font.Font(None,36)
textstring="HIER STEHT DER TEXT"
text=font.render(textstring,1,(BLACK))
# screen = pygame.transform.rotate(screen,270)
# Textanzeigen und drehen
# text = pygame.transform.rotate(text,270) 
# Testausgabe fuer Debug
textpos = text.get_rect(centerx=background.get_width()/2+15,centery=background.get_height()-10) # 225
background.blit(text, textpos)
screen.blit(background, (0, 0))
pygame.display.flip()
running = True
os.system('clear')
# irnumber
irnumber=[]
# Schleife
while running:
   for event in pygame.event.get():
      if event.type == QUIT:
         pygame.quit()
         sys.exit()
         running = False
      elif event.type == pygame.MOUSEBUTTONDOWN:
#         background.blit(Img, (x, y))
         print("Position: %sx%s\n" % pygame.mouse.get_pos())
         set_background()
         set_icons()
         mousex, mousey = pygame.mouse.get_pos()
         if mousey < (icon_y + distance_y):
         #
            if mousex < ( start_x + icon_x + distance_x):
               textstring="TV"
            # 
            elif mousex < (start_x + 2 * (icon_x + distance_x)): #130:
               textstring="MUTE"
            # 
            elif mousex < (start_x + 3 * (icon_x + distance_x)): #200:
            #
               textstring="PWR"
             # irnumber.append(textstring)
            irnumber.insert(0,textstring)
         elif mousey < (start_x + (2 * (icon_x + distance_x))): #100:
         # 
            if mousex < ( start_x + icon_x + distance_x):
            # 
               textstring="1"
            elif mousex < (start_x + 2 * (icon_x + distance_x)):
            # 
               textstring="2"
            elif mousex < (start_x + 3 * (icon_x + distance_x)):
            #
               textstring="3"
            # irnumber.append(textstring)
            irnumber.insert(0,textstring)
         elif mousey < (start_x + (3 * (icon_x + distance_x))): # 150:
         #
            if mousex < ( start_x + icon_x + distance_x):
            # 
               textstring="4"
            elif mousex < (start_x + 2 * (icon_x + distance_x)):
            # 
               textstring="5"
            elif mousex < (start_x + 3 * (icon_x + distance_x)):
            #
               textstring="6"
            # irnumber.append(textstring)
            irnumber.insert(0,textstring)
         elif mousey < (start_x + (4 * (icon_x + distance_x))): # 200:
         #
            if mousex < ( start_x + icon_x + distance_x):
            # 
               textstring="7"
            elif mousex < (start_x + 2 * (icon_x + distance_x)):
            # 
               textstring="8"
            elif mousex < (start_x + 3 * (icon_x + distance_x)):
            #
               textstring='9'
            # irnumber.append(textstring)
            irnumber.insert(0,textstring)
         elif mousey < (start_x + (5 * (icon_x + distance_x))): # 250:
         #
            if mousex < ( start_x + icon_x + distance_x):
            # 
               textstring="<"
            elif mousex < (start_x + 2 * (icon_x + distance_x)):
            # 
               textstring="0"
            elif mousex < (start_x + 3 * (icon_x + distance_x)):
            #
               textstring='>'
            # irnumber.append(textstring)
            irnumber.insert(0,textstring)
         elif mousey > ((start_x + (5 * (icon_x + distance_x))) + 1): # 250:
            textstring=str(pygame.mouse.get_pos())
         strirnumber=""
         for i in irnumber:
            strirnumber = strirnumber+str(i)
         print "Gewaehlte Taste: ", irnumber[0]# strirnumber
         text=font.render(strirnumber,1,(WHITE))
         background.blit(text, textpos)
         screen.blit(background, (0, 0))
         if textpos.collidepoint(pygame.mouse.get_pos()):
            pygame.quit()
            sys.exit()
            running = False
      elif event.type == KEYDOWN and event.key == K_ESCAPE:
         running = False
   pygame.display.update()
   fpsClock.tick(FPS)
# -------------------- EOF -----------------------

