#!/usr/bin/python 
# -*- coding: utf-8 -*- 
# ----------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016
# ----------------------------------------------------
# Datei: pygame-step05.py
#
# schritt 5: Einbinden LIRC-irsend Kommandos
#
# Einbinden von Fernbedienung, hier Tastenbezeichnung aus lircd.conf.NAME
# bspw. irsend SEND_ONCE VUPLUS KEY_EXIT
#
# 0000000000000001 KEY_POWER
# 0000000000000002 KEY_NUMERIC_0
# 0000000000000003 KEY_NUMERIC_1
# 0000000000000004 KEY_NUMERIC_2
# 0000000000000005 KEY_NUMERIC_3
# 0000000000000006 KEY_NUMERIC_4
# 0000000000000007 KEY_NUMERIC_5
# 0000000000000008 KEY_NUMERIC_6
# 0000000000000009 KEY_NUMERIC_7
# 000000000000000a KEY_NUMERIC_8
# 000000000000000b KEY_NUMERIC_9
# 000000000000000c KEY_OK
# 000000000000000d KEY_PAUSE
# 000000000000000e KEY_PLAY
# 000000000000000f KEY_BLUE
# 0000000000000010 KEY_YELLOW
# 0000000000000011 KEY_GREEN
# 0000000000000012 KEY_RED
# 0000000000000013 KEY_MENU
# 0000000000000014 KEY_CHANNELUP
# 0000000000000015 KEY_CHANNELDOWN
# 0000000000000016 KEY_VOLUMEUP
# 0000000000000017 KEY_VOLUMEDOWN
# 0000000000000018 KEY_EXIT
# 0000000000000019 KEY_MUTE
# 000000000000001a KEY_LEFT
# 000000000000001b KEY_RIGHT
# 000000000000001c KEY_TV
# 000000000000001d KEY_RECORD
# 000000000000001e KEY_RADIO
# 000000000000001f KEY_STOP
# 0000000000000020 KEY_TEXT
#
# Aufruf ueber subprocess
#
# subprocess.call(["irsend", "SEND_ONCE", "VUPLUS", "KEY_POWER"])
# ------------------------------------------------------------------
import pygame, sys, os, time
import subprocess
from pygame.locals import *
# Init PyGame
pygame.init()
FPS = 30 # frames per second 
fpsClock = pygame.time.Clock()
screen = pygame.display.set_mode((240, 320), 0, 32) # 320x240
pygame.display.set_caption('PyGame: Schritt 5')
# Farben definieren nach RGB-Schema
BLACK=(0,0,0)
WHITE=(255,255,255)
RED=(255,0,0)
BLUE=(0,0,255)
FUCHSIA=(255,0,255)
# Hintergrund aufbauen
background = pygame.Surface(screen.get_size())
#
ICONSPATH="icons/"

icon_x = 50
icon_y = 50
start_x = 10
start_y = 10
distance_x = 5
distance_y = 5
#
def set_background():
  global background
  background = background.convert()
  background.fill(BLACK)
  return;

def set_icons():
  Img_0 = pygame.image.load(ICONSPATH+'vu000.png')
  x_0 = start_x
  y_0 = start_y
  background.blit(Img_0, (x_0, y_0))
  Img_1 = pygame.image.load(ICONSPATH+'vu001.png')
  x_1 = x_0 + (icon_x + distance_x)
  y_1 = y_0
  background.blit(Img_1, (x_1, y_1))
  Img_2 = pygame.image.load(ICONSPATH+'vu002.png')
  x_2 = x_0 + 2 * (icon_x + distance_x)
  y_2 = y_0
  background.blit(Img_2, (x_2, y_2))
  # ---------------------
  Img_3 = pygame.image.load(ICONSPATH+'vu003.png')
  x_3 = x_0
  y_3 = y_0 + (icon_y + distance_y)
  background.blit(Img_3, (x_3, y_3))
  Img_4 = pygame.image.load(ICONSPATH+'vu004.png')
  x_4 = x_1
  y_4 = y_3
  background.blit(Img_4, (x_4, y_4))
  Img_5 = pygame.image.load(ICONSPATH+'vu005.png')
  x_5 = x_2
  y_5 = y_3
  background.blit(Img_5, (x_5, y_5))
  # ---------------------
  Img_6 = pygame.image.load(ICONSPATH+'vu006.png')
  x_6 = x_0
  y_6 = y_0 + 2 * (icon_y + distance_y)
  background.blit(Img_6, (x_6, y_6))
  Img_7 = pygame.image.load(ICONSPATH+'vu007.png')
  x_7 = x_1
  y_7 = y_6
  background.blit(Img_7, (x_7, y_7))
  Img_8 = pygame.image.load(ICONSPATH+'vu008.png')
  x_8 = x_2
  y_8 = y_6
  background.blit(Img_8, (x_8, y_8))
  # ---------------------
  Img_9 = pygame.image.load(ICONSPATH+'vu009.png')
  x_9 = x_0
  y_9 = y_0 + 3 * (icon_y + distance_y)
  background.blit(Img_9, (x_9, y_9))
  Img_10 = pygame.image.load(ICONSPATH+'vu010.png')
  x_10 = x_1
  y_10 = y_9
  background.blit(Img_10, (x_10, y_10))
  Img_11 = pygame.image.load(ICONSPATH+'vu011.png')
  x_11 = x_2
  y_11 = y_9
  background.blit(Img_11, (x_11, y_11))
  # ---------------------
  Img_12 = pygame.image.load(ICONSPATH+'vu012.png')
  x_12 = x_0
  y_12 = y_0 + 4 * (icon_y + distance_y)
  background.blit(Img_12, (x_12, y_12))
  Img_13 = pygame.image.load(ICONSPATH+'vu013.png')
  x_13 = x_1
  y_13 = y_12
  background.blit(Img_13, (x_13, y_13))
  Img_14 = pygame.image.load(ICONSPATH+'vu014.png')
  x_14 = x_2
  y_14 = y_12
  background.blit(Img_14, (x_14, y_14))
  return;

set_background()
set_icons()
# Textanzeige
font=pygame.font.Font(None,36)
textstring="HIER STEHT DER TEXT"
text=font.render(textstring,1,(BLACK))
# screen = pygame.transform.rotate(screen,270)
# Textanzeigen und drehen
# text = pygame.transform.rotate(text,270) 
# Testausgabe fuer Debug
textpos = text.get_rect(centerx=background.get_width()/2+15,centery=background.get_height()-10) # 225
background.blit(text, textpos)
screen.blit(background, (0, 0))
pygame.display.flip()
running = True
os.system('clear')
# irnumber
irnumber=[]
# Schleife
while running:
   for event in pygame.event.get():
      if event.type == QUIT:
         pygame.quit()
         sys.exit()
         running = False
      elif event.type == pygame.MOUSEBUTTONDOWN:
#         background.blit(Img, (x, y))
         print("Position: %sx%s\n" % pygame.mouse.get_pos())
         set_background()
         set_icons()
         mousex, mousey = pygame.mouse.get_pos()
         if mousey < (icon_y + distance_y):
         #
            if mousex < ( start_x + icon_x + distance_x):
               textstring="TV"
               ir_cmd = subprocess.call(["irsend", "SEND_ONCE", "VUPLUS", "KEY_TV"])
            # 
            elif mousex < (start_x + 2 * (icon_x + distance_x)):
               textstring="MUTE"
               ir_cmd = subprocess.call(["irsend", "SEND_ONCE", "VUPLUS", "KEY_MUTE"])
            # 
            elif mousex < (start_x + 3 * (icon_x + distance_x)):
            #
               textstring="PWR"
               ir_cmd = subprocess.call(["irsend", "SEND_ONCE", "VUPLUS", "KEY_POWER"])
            irnumber.insert(0,textstring)
         elif mousey < (start_x + (2 * (icon_x + distance_x))): 
         # 
            if mousex < ( start_x + icon_x + distance_x):
            # 
               textstring="1"
               ir_cmd = subprocess.call(["irsend", "SEND_ONCE", "VUPLUS", "KEY_NUMERIC_1"])
            elif mousex < (start_x + 2 * (icon_x + distance_x)):
            # 
               textstring="2"
               ir_cmd = subprocess.call(["irsend", "SEND_ONCE", "VUPLUS", "KEY_NUMERIC_2"])
            elif mousex < (start_x + 3 * (icon_x + distance_x)):
            #
               textstring="3"
               ir_cmd = subprocess.call(["irsend", "SEND_ONCE", "VUPLUS", "KEY_NUMERIC_3"])
            irnumber.insert(0,textstring)
         elif mousey < (start_x + (3 * (icon_x + distance_x))):
         #
            if mousex < ( start_x + icon_x + distance_x):
            # 
               textstring="4"
               ir_cmd = subprocess.call(["irsend", "SEND_ONCE", "VUPLUS", "KEY_NUMERIC_4"])
            elif mousex < (start_x + 2 * (icon_x + distance_x)):
            # 
               textstring="5"
               ir_cmd = subprocess.call(["irsend", "SEND_ONCE", "VUPLUS", "KEY_NUMERIC_5"])
            elif mousex < (start_x + 3 * (icon_x + distance_x)):
            #
               textstring="6"
               ir_cmd = subprocess.call(["irsend", "SEND_ONCE", "VUPLUS", "KEY_NUMERIC_6"])
            irnumber.insert(0,textstring)
         elif mousey < (start_x + (4 * (icon_x + distance_x))):
         #
            if mousex < ( start_x + icon_x + distance_x):
            # 
               textstring="7"
               ir_cmd = subprocess.call(["irsend", "SEND_ONCE", "VUPLUS", "KEY_NUMERIC_7"])
            elif mousex < (start_x + 2 * (icon_x + distance_x)):
            # 
               textstring="8"
               ir_cmd = subprocess.call(["irsend", "SEND_ONCE", "VUPLUS", "KEY_NUMERIC_8"])
            elif mousex < (start_x + 3 * (icon_x + distance_x)):
            #
               textstring='9'
               ir_cmd = subprocess.call(["irsend", "SEND_ONCE", "VUPLUS", "KEY_NUMERIC_9"])
            irnumber.insert(0,textstring)
         elif mousey < (start_x + (5 * (icon_x + distance_x))):
         #
            if mousex < ( start_x + icon_x + distance_x):
            # 
               textstring="<"
               ir_cmd = subprocess.call(["irsend", "SEND_ONCE", "VUPLUS", "KEY_LEFT"])
            elif mousex < (start_x + 2 * (icon_x + distance_x)):
            # 
               textstring="0"
               ir_cmd = subprocess.call(["irsend", "SEND_ONCE", "VUPLUS", "KEY_NUMERIC_0"])
            elif mousex < (start_x + 3 * (icon_x + distance_x)):
            #
               textstring='>'
               ir_cmd = subprocess.call(["irsend", "SEND_ONCE", "VUPLUS", "KEY_RIGHT"])
            irnumber.insert(0,textstring)
         elif mousey > ((start_x + (5 * (icon_x + distance_x))) + 1):
            textstring=str(pygame.mouse.get_pos())
         strirnumber=""
         for i in irnumber:
            strirnumber = strirnumber+str(i)
         print "Gewaehlte Taste: ", irnumber[0]
         if ir_cmd:
            print "irsend-Fehler "
         else:
            print "IR-Signal gesendet"
         text=font.render(strirnumber,1,(WHITE))
         background.blit(text, textpos)
         screen.blit(background, (0, 0))
         if textpos.collidepoint(pygame.mouse.get_pos()):
            pygame.quit()
            sys.exit()
            running = False
      elif event.type == KEYDOWN and event.key == K_ESCAPE:
         running = False
   pygame.display.update()
   fpsClock.tick(FPS)
# -------------------- EOF -----------------------

