#!/bin/bash
# -----------------------------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016/2017
# -----------------------------------------------------------------------
# raspitimelapse.sh
# Dateihandling
time_intervall_ms=30000; # alle 5 minuten
time_intervall=`echo $time_intervall_ms/1000 | bc`;
ZAEHLERMAX=2880;
ZAEHLERNEU=0;
FILE_PATH="/home/pi/IMG/";
FILEIMG="IMG_";
FILEEXTJPG=".jpg";
#-------------------------------------------------------------------------
function setnew_zaehler(){
	if [ "$(ls -A $FILE_PATH 2> /dev/null)" == "" ]; then 
		echo "[raspitimelapse] $FILE_PATH ist leer"; 
		ZAEHLERNEU=0;
		ZAEHLERAKTUELL=0;
	else 
		echo "[raspitimelapse] $FILE_PATH ist nicht leer";
		ZAEHLERAKTUELL=`ls -tr $FILE_PATH$FILEIMG* | tail -1 | cut -d '_' -f 2 | cut -d '.' -f 1`;
		if [ ! -z "$ZAEHLERAKTUELL" ]; then
			ZAEHLERNEU=`echo $ZAEHLERAKTUELL+1 | bc`;
		else
			ZAEHLERNEU=0;
		fi;
	fi;
}
#-------------------------------------------------------------------------
function takeSnapshot() {
	setnew_zaehler;
	FILENAMEIMG=$FILE_PATH$FILEIMG$ZAEHLERNEU$FILEEXTJPG;
	if [ -e  "/usr/bin/franzisCAM" ]; then
		echo -e "\n\n[raspitimelapse] OK, franzisCAM bereits installiert";
		franzisCAM -n -o $FILENAMEIMG;
		echo "[raspitimelapse] Aufnahme:" $FILEIMG$ZAEHLERNEU$FILEEXTJPG " wurde auf der Speicherkarte gespeichert";
	else
        echo -e "\n\n[raspitimelapse] kein franzisCAM installiert, Pruefung ob raspistill vorhanden..";
		if [ -e  "/usr/bin/raspistill" ]; then
			echo -e "\n\n[raspitimelapse] OK, raspistill ist installiert";
			raspistill -n -o $FILENAMEIMG # raspistill -n -o $FILENAMEIMG;
			echo "[raspitimelapse] Aufnahme:" $FILEIMG$ZAEHLERNEU$FILEEXTJPG " wurde auf der Speicherkarte gespeichert";
		else
			error_exit "\n\n[raspitimelapse] Weder franzisCAM noch raspistill installiert.. Keine Aufnahmen moeglich!";
		fi;
	fi;
}
#--------------------------------------------------------------------------
# main
clear
echo "[raspitimelapse] "`date +%s` "! raspitimelapse.sh"
mkdir -p /home/pi/IMG
cd /home/pi
while [ $ZAEHLERNEU -le "$ZAEHLERMAX" ]; do
    echo "[raspitimelapse] Aufnahme erfolgt alle " $time_intervall " Sekunden";
    takeSnapshot;
	sleep $time_intervall;
done
exit 0
# --------------------------- EOF ---------------------------------------
