#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-
# E.F.Engelhardt, Franzis Verlag, 2016/20171
#
# Pfad \sim900
# Datei: sim900-gsmkoordinaten.py
#----------------------------------------------------------------------
MMAP_URL = 'http://www.google.com/glm/mmap'
GOOGLE_MAPS_URL  = 'http://maps.google.com'
import shlex
import csv
import urllib2
import serial
import time
# ---------------------------------------------------------------------
INTRO_READ_CREG='+CREG:'
INTRO_READ_COPS='+COPS:'
# ---------------------------------------------------------------------
# Bernburg '4858', '019F'
RESPONSE_READ_CREG ='AT+CREG?\r\r\n+CREG: 2,1,"4858","019F"\r\n\r\nOK\r\n'
RESPONSE_READ_COPS='AT+COPS?\r\r\n+COPS: 0,2,"26201"\r\n\r\nOK\r\n'
# ---------------------------------------------------------------------
def sendCmdEncode(cmd='AT',com='/dev/ttyAMA0'):
   ser = serial.Serial(com, 115200, timeout=5)
   cmd = cmd +'\r'
   ser.write(cmd.encode())
   time.sleep(1)
   response = ser.read(64)
#   ser.close # ?
   return response
# ---------------------------------------------------------------------
def fetch_cell(com='/dev/ttyAMA0'):
    print "| SIM900 DEBUG Oeffne Modem... und hole MCC und MNC"
    print '| SIM900 DEBUG Sende AT+COPS=0,2...'
    sendCmdEncode('AT+COPS=0,2')
    print '| SIM900 DEBUG Sende AT+COPS?'
    out = sendCmdEncode('AT+COPS?')
    print "------------------------------------"
    print "| SIM900 DEBUG Antwort:", out
    tmp = shlex.split(out)
    print "| SIM900 DEBUG zerlegen: 1-tmp", tmp
    # tmp ===> ['AT+COPS?', '+COPS:', '0,2,26201', 'OK']
    tmp = tmp[tmp.index('+COPS:') + 1] # '0,2,26201'
    print "| SIM900 DEBUG 2-tmp", tmp
    tmp = csv.reader([tmp])
    print "| SIM900 DEBUG 3-tmp", tmp
    tmp = [row for row in tmp][-1] # ['0', '2', '26201']
    print "| SIM900 DEBUG 4-tmp", tmp
    mcc_mnc_dec = int(tmp[-2], 16) # 
    print "| SIM900 mcc_mnc_dec:", mcc_mnc_dec
    # dito mit LAC und CID
    print '| SIM900 DEBUG Sende AT+CREG?'
    out = sendCmdEncode('AT+CREG?')
#    out = RESPONSE_READ_CREG
    tmp = shlex.split(out)
    print "| SIM900 DEBUG 5-tmp", tmp
    # tmp ===> ['AT+CREG?', '+CREG:', '2,1,8174,EA45', 'OK']
    tmp = tmp[tmp.index('+CREG:') + 1] #
    print "| SIM900 DEBUG 6-tmp", tmp # 1,8174,E76A
    tmp = csv.reader([tmp])
    print "| SIM900 DEBUG 7-tmp", tmp
    tmp = [row for row in tmp][-1] #
    print "| SIM900 DEBUG 8-tmp", tmp
    print "| SIM900 Berechne LAC und CID.."
    lac_dec = int(tmp[-2], 16) # 
    cid_dec = int(tmp[-1], 16) # 
    print "| SIM900 lac_dec", lac_dec
    print "| SIM900 cid_dec", cid_dec
    return cid_dec, lac_dec, mcc_mnc_dec
# ---------------------------------------------------------------------
def fetch_cell_ohne_AT(comm='/dev/ttyAMA0'):
    print "| Parsen mit festen MCC, MNC Werten"
    out = 'AT+COPS?\r\r\n+COPS: 0,2,"26201"\r\n\r\nOK\r\n'
    print "| out: ", out
    tmp = shlex.split(out)
    tmp = tmp[tmp.index('+COPS:') + 1]
    tmp = csv.reader([tmp])
    tmp = [row for row in tmp][-1] # ['0', '2', '26201', '0']
    mcc_mnc_dec = int(tmp[-2], 16) # 
    # Hole LAC und CID
    out = RESPONSE_READ_CREG
    print "| out: ", out
    print "| "
    tmp = shlex.split(out)
    # tmp ===> ['AT+CREG?', '+CREG:', '2,1,'4858','019F', 'OK']
    tmp = tmp[tmp.index('+CREG:') + 1] # '2,1,4858,019F'
    tmp = csv.reader([tmp])
    tmp = [row for row in tmp][-1] # ['2', '1', '4858', '019F']

    lac_dec = int(tmp[-2], 16) # lac_dec =  18520
    cid_dec = int(tmp[-1], 16) # cid_dec =  415
                               #  mcc_mnc_dec =  2
    print "|  lac_dec = ",  lac_dec
    print "|  cid_dec = ", cid_dec
    print "|  mcc_mnc_dec = ", mcc_mnc_dec
    return cid_dec, lac_dec, mcc_mnc_dec
# ----------------------------------------------------------------
def get_location_by_cell(cid_dec, lac_dec, mcc_mnc_dec):
    a = '000E00000000000000000000000000001B0000000000000000000000030000'
        h1, h2 = divmod(mcc_mnc_dec, 100) # 152833 >>> (1528, 33)
    b = hex(cid_dec)[2:].zfill(8) + hex(lac_dec)[2:].zfill(8)
    # b >>> '0000019f00004858'
    c = hex(h1)[2:].zfill(8) + hex(h2)[2:].zfill(8)
    # c >>> '0000000000000002'
    print "a", a
    print "b", b
    print "c", c
    data = (a + b + c + 'FFFFFFFF00000000').decode('hex')
    response = urllib2.urlopen(MMAP_URL, data)
    res_hex = response.read().encode('hex')
    # res_hex >>> '000e1b000000000315d30c00b3c60c00000b200000001e0000'
    latitude = float(int(res_hex[14:22], 16)) / 1000000 # 
    longitude = float(int(res_hex[22:30], 16)) / 1000000 #
    return latitude, longitude
# ---------------------------------------------------------------------
def format_googlemaps_link(latitude, longitude):
    return '%s?q=%f,%f' % (GOOGLE_MAPS_URL, latitude, longitude)
# ---------------------------------------------------------------------
if __name__ == '__main__':
    print "-"*60
    cid_dec, lac_dec, mcc_mnc_dec = fetch_cell_ohne_AT()
#  get_location_by_cell funkt. nur bei Internetnetzwerkverbindung!
#    lat, lon = get_location_by_cell(cid_dec, lac_dec, mcc_mnc_dec)
    print "-"*60
#    print format_googlemaps_link(lat, lon)
    cid_dec, lac_dec, mcc_mnc_dec = fetch_cell()#_DEBUG()
 #   lat, lon = get_location_by_cell(cid_dec, lac_dec, mcc_mnc_dec)    
 #   print format_googlemaps_link(lat, lon)
    print "-"*60
#    ser.close
# ---------------------------- EOF ------------------------------------
