# -*- coding: iso-8859-15 -*- 
#!/usr/bin/python
# E.F.Engelhardt, Franzis Verlag, 2016/2017
#
# Pfad \sim900 
# Datei sim900-sende-gps-sms-step2.py
#
# ---------------------------------------------------------------------
import serial 
import time
import RPi.GPIO as GPIO
import subprocess
import os
import shlex
# ---------------------------------------------------------------------
GPIO.setmode(GPIO.BCM) # GPIO Mode
# ---------------------------------------------------------------------
GPIO_RST = 18 # GPIO18 (Ausgang) / Pin 12 / wiring Pi: 1
GPIO_PWR = 17 # GPIO17 (Ausgang) / Pin 11 / wiring Pi: 0
# ---------------------------------------------------------------------
SIM900_PIN='1234' # Format xxxx 
SIM900_CENTER='+491710760000' 
SIM900_NUMBER='+49170123467' # Ziel-Telefonnummer 
MSGDATA = '' # Leere Nachricht 
ALARMSMS = 'PIWOBISTDU' # Suchbegriff zum Parsen in SMS
# ---------------------------------------------------------------------
def cmd_exists(cmd):
    return subprocess.call("type " + cmd, shell=True, 
         stdout=subprocess.PIPE, stderr=subprocess.PIPE) == 0
# ---------------------------------------------------------------------
def get_GPSPos():
   delay=10
   GPSPIPE="/usr/bin/gpspipe" # Pfad zu Programm
   print "| [GPS] Check ob ", GPSPIPE ," vorhanden..."
   if cmd_exists(GPSPIPE):
      # "vorhanden "
      print "| [GPS] Koordinaten..."
      LONGITUDE="gpspipe -w -n 5 | grep lon | grep -i -m 1 tpv | cut -d ',' -f8 | cut -d ':' -f2"
      LATITUDE="gpspipe -w -n 5 | grep lat | grep -i -m 1 tpv | cut -d ',' -f7 | cut -d ':' -f2"
      longitude=os.popen(LONGITUDE).read()
      longitude=longitude.strip()
      time.sleep(1)
      latitude=os.popen(LATITUDE).read()
      latitude=latitude.strip()
      print "| Laengengrad: ", longitude
      print "| Breitengrad: ", latitude
      google ="| Google Maps: https://maps.google.com/maps?q="
      google=google+latitude+","+longitude
      print google
      time.sleep(delay)
   return google
# ---------------------------------------------------------------------
def init_SIM900():
   GPIO.setup(GPIO_RST, GPIO.OUT)
   time.sleep(1)
   GPIO.setup(GPIO_PWR, GPIO.OUT)
   time.sleep(1)
   print "| [SIM900] GPIO_RST initialisiert.."
   print "| [SIM900] GPIO_PWR initialisiert.."
   return
# ---------------------------------------------------------------------
def PowerOn_SIM900():
   GPIO.output(GPIO_PWR,GPIO.HIGH)
   time.sleep(1)
   GPIO.output(GPIO_PWR,GPIO.LOW)
   print "| [SIM900] wurde eingeschaltet"
   print "| [SIM900] Registering SIM...";
   time.sleep(15) # Warten auf Registrierung SIM
   return 1
# --------------------------------------------------------------------- 
def sendCmdEncode(cmd='AT',com='/dev/ttyAMA0',ok='OK'):
   timeout=1
   if cmd=='AT+CPOWD=1':
      ok = 'NORMAL POWER DOWN'
      timeout=5
   cmd = cmd +'\r'
   ser.write(cmd.encode())
   time.sleep(timeout)
   ret = ser.read(2048)#64)
#   print ret # fuer DEBUG
   return ret
# ---------------------------------------------------------------------
def _PowerOff_SIM900(): # falls 'AT+CPOWD=1' nicht funktioniert
   GPIO.output(GPIO_PWR,GPIO.LOW)
   time.sleep(1)
   GPIO.output(GPIO_PWR,GPIO.HIGH)
   time.sleep(2)
   GPIO.output(GPIO_PWR,GPIO.LOW)
   time.sleep(3)
   print "| [SIM900] wurde ausggeschaltet"
   return
# ---------------------------------------------------------------------
def PowerOff_SIM900(): 
   pow = sendCmdEncode('AT+CPOWD=1')
   print "| [SIM900] wurde ausgeschaltet", pow
   return 1
# ---------------------------------------------------------------------
def Reset_SIM900():
   GPIO.output(GPIO_RST,GPIO.LOW)
   print "| [SIM900] Reset.."
   time.sleep(1) 
   GPIO.output(GPIO_RST,GPIO.HIGH)
   time.sleep(1)
   GPIO.output(GPIO_RST,GPIO.LOW)
   return
# ---------------------------------------------------------------------
def cmd_chkSMS(chkData=ALARMSMS, smsCenter=SIM900_CENTER, smsPin=SIM900_PIN):
   if chkData is None:
      print "| [SIM900] Fehler: Keine Daten zwecks Suche angegeben."
      sys.exit(-1)
   # Check ob Modemverbindung ok
   if(sendCmdEncode('AT').find("OK")<>-1):
      print "| [SIM900] Modem online..";
      if not 'READY' in sendCmdEncode('AT+CPIN?'): # PIN benoetigt?
         sendCmdEncode('AT+CPIN="'+smsPin+'"') # PIN eingeben
      if(sendCmdEncode('AT+CREG?').find("+CREG: 2,1")<>-1) or (sendCmdEncode('AT+CREG?').find("+CREG: 0,1")<>-1):
         print '| [SIM900] SIM im Mobilfunknetz eingebucht..'
         sendCmdEncode('AT+CMGF=1') # Text Modus einschalten
         # bei Multi-SIM die aktuelle Karte als SMS-Karte fuer Versand und Empfang festlegen
         sendCmdEncode('ATD*222#')
         sendCmdEncode('AT+CSCA="'+smsCenter+'"') # sms message center einstellen
         # ggf. etwas warten und zeit fuer SMS-Empfang zu haben
         # Modem konfigurieren fuer SMS-Empfang und Umgang
         sendCmdEncode('AT+CNMI=2,1,0,0,1')
         sendCmdEncode('AT+CMGL=\"REC UNREAD\"') # UNREAD Nachrichten
         print "| SMS werden empfangen...."
         #         time.sleep(60) # wartezeit
         # in allen vorhandenen Nachrichten suchen -> AT+CMGL="ALL"
         # AT+CMGL=0 alle ungelesenen
         # AT+CMGL=1 alle gelesenen
         # AT+CMGL=2 - alle gespeicherten entwuerfe
         # AT+CMGL=3 - alle gespeicherte verschickten SMS
         # AT+CMGL=4 - alle vorhandenen SMS
         chkMSG= sendCmdEncode('AT+CMGL=\"ALL\"')
         # print 'chkMSG', chkMSG
         chkCMGL=chkMSG
         tmp = shlex.split(chkCMGL)
         #  print "temp: ", tmp
         #  print "Anzahl Elemente:", len(tmp) 
         i=0
         sms = 0
         global SIM900_NUMBER
         while i < (len(tmp)-2):
         # print 'Element i', i, 'mit Inhalt: ', tmp[i] 
            if tmp[i] == 'AT+CMGL=ALL': # erste zeile ueberspringen
               i = i + 1
            if tmp[i] == '+CMGL:': # SMS 
               i = i + 1
               sms = sms + 1
               sms_absender = tmp[i]
               sms_store, sms_status, sms_sender, sms_leer, sms_datum, sms_uhrzeit =sms_absender.split(",",5)
               i = i + 1
               sms_inhalt = tmp[i]
               print "| \n| SMS Nr.: ", sms, "\n| Absender: ", sms_sender, "\n| Inhalt: ", sms_inhalt, '\n| Speicherort Nr.:', sms_store, '\n| Status: ',sms_status,'\n|'
               #
               if chkData in sms_inhalt:
                  print "| [SIM900] ALARM-Koordinaten wurden angefordert!"  
                  SIM900_NUMBER=sms_sender # passe Antwort an Ziel-Telefonnummer an
                  # Loesche SMS aus Speicher mit AT+CMGD= -> sms_store
#                  if sendCmdEncode('AT+CMGD='+sms_store): # normal loeschen
                  if sendCmdEncode('AT+CMGD='+sms_store+',2'): 
                  # Option 4 = alle gespeicherten nachrichten loeschen
                  # Option 3 = "received read", "stored unsent" oder "stored sent"
                  # Option 2 = "received read" oder "stored sent" 
                     print "| [SIM900] Alarm-SMS an Speicherplatz: ", sms_store, " wurde entfernt."
                  return 1
               print "| [SIM900] Alarm-Aufruf nicht gefunden.."
               #
            if i < len(tmp): 
               i = i + 1
            else:
               break                         
   return 0
# --------------------------------------------------------------------- 
def cmd_sendSMS(smsNumber=SIM900_NUMBER, msgData=MSGDATA, smsCenter=SIM900_CENTER, smsPin=SIM900_PIN):
   if smsNumber is None:
      print "| [SIM900] Fehler: Keine Ziel-Telefonnummer angegeben."
      sys.exit(-1)
   if msgData is None:
      print "| [SIM900] Fehler: Kein Inhalt in SMS-Nachricht vorhanden."
      sys.exit(-1)
   # Check ob Modemverbindung ok
   if(sendCmdEncode('AT').find("OK")<>-1):
      print "| [SIM900] Modem online..";
      if not 'READY' in sendCmdEncode('AT+CPIN?'): # PIN benoetigt?
         sendCmdEncode('AT+CPIN="'+smsPin+'"') # PIN eingeben
      if(sendCmdEncode('AT+CREG?').find("+CREG: 2,1")<>-1) or (sendCmdEncode('AT+CREG?').find("+CREG: 0,1")<>-1):
         print '| [SIM900] SIM im Mobilfunknetz eingebucht..'
         sendCmdEncode('AT+CMGF=1') # Text Modus einschalten
         # bei Multi-SIM die aktuelle Karte als SMS-Karte fuer Versand und Empfang festlegen
         sendCmdEncode('ATD*222#')
         sendCmdEncode('AT+CSCA="'+smsCenter+'"') # sms message center einstellen
         sendCmdEncode('AT+CMGS="'+smsNumber+'"') # Versand starten
         sendCmdEncode(msgData+'\x1A\r\n') # Versand beenden
         print "| [SIM900] Nachricht erfolgreich verschickt!" # Bestaetigung
         return 1
      elif sendCmdEncode('AT+CREG?'):
         print '| [SIM900] SIM nicht im Mobilfunknetz eingebucht..'
         return 0
   return 0
# ---------------------------------------------------------------------
if __name__ == '__main__':
    print "-"*60
    com='/dev/ttyAMA0'
    ser = serial.Serial(com, 115200, timeout=5)
    # Einschalten
    init_SIM900()
    PowerOn_SIM900()
    # get_GPSPos()
    msgData=get_GPSPos()
	msgData='ALARM:\rAuto befindet sich gerade:\r'+msgData
    if cmd_chkSMS()==1:
       print "|\n| ALARM ALRAM ALARM\n|"
       # sende Koordinaten ueber SMS    
       cmd_sendSMS(SIM900_NUMBER,msgData)
    print "-"*60
    # Ausschalten ueber AT-Kommando
    PowerOff_SIM900()
    ser.close
    GPIO.cleanup() # GPIO aufraeumen 
    print "-"*60
# ------------------------------- EOF ---------------------------------
