#!/usr/bin/env python
# -*- coding: utf-8 -*- 
# E.F.Engelhardt, Franzis Verlag, 2016/2017
#
# Pfad \sim900
# Datei: sim900-step1.py
# -----------------------------------------------------------------------
import time 
import serial
import os
import RPi.GPIO as GPIO
#  -----------------------------------------------------------------------
GPIO.setmode(GPIO.BCM) # GPIO Mode
#  -----------------------------------------------------------------------
GPIO_RST = 18 # GPIO18 (Ausgang) / Pin 12 / wiring Pi: 1
GPIO_PWR = 17 # GPIO17 (Ausgang) / Pin 11 / wiring Pi: 0

# ---------------------------------------------- 
# Start Python-Skript 
# ----------------------------------------------
delay = 5
# Dauer-Schleife
os.system('clear') 
# ----------------------------------------------
def init_SIM900():
   GPIO.setup(GPIO_RST, GPIO.OUT)
   time.sleep(1)   
   GPIO.setup(GPIO_PWR, GPIO.OUT)
   time.sleep(1)
   print "| [SIM900] GPIO_RST initialisiert.."
   print "| [SIM900] GPIO_PWR initialisiert.."
   return;
# ----------------------------------------------
def PowerOn_SIM900():
   GPIO.output(GPIO_PWR,GPIO.HIGH)
   time.sleep(1)
   GPIO.output(GPIO_PWR,GPIO.LOW)
   print "| [SIM900] wurde eingeschaltet"
   print "| [SIM900] Registering SIM...";
   time.sleep(15); # Warten auf Registrierung SIM
   return;
# ----------------------------------------------
def PowerOff_SIM900():
   GPIO.output(GPIO_PWR,GPIO.HIGH)
   time.sleep(1)
   if str(Check_SIM900())== '1':
      print "| [SIM900] GPIO.output(GPIO_PWR,GPIO.HIGH) setzen, da Modem noch an!"
      GPIO.output(GPIO_PWR,GPIO.LOW)
      time.sleep(1)
      GPIO.output(GPIO_PWR,GPIO.HIGH)
   print "| [SIM900] wurde ausgeschaltet"
   GPIO.output(GPIO_PWR,GPIO.LOW)
   return;
# ----------------------------------------------
def Reset_SIM900():
   GPIO.output(GPIO_RST,GPIO.LOW)
   print "| [SIM900] Reset.."
   time.sleep(1)
   GPIO.output(GPIO_RST,GPIO.HIGH)
   time.sleep(1)
   GPIO.output(GPIO_RST,GPIO.LOW)
   return;
# ----------------------------------------------
def Check_SIM900():
   print "| [SIM900] Check for Modem..";
   ser=serial.Serial('/dev/ttyAMA0',9600,timeout=1);
   ser.open()
   ser.write("at\r")
   time.sleep(3)
   line=ser.read(size=64) 
   # Modem init STring schicken
   ser.write('AT S7=45 S0=0 L1 V1 X4 &c1 E1 Q0\r')
   time.sleep(3)
   # rueckmeldung auf at befehl auswerten, wenn OK enthalten, dann Modem noch an!
   response=ser.read(size=200)
   if(response.find("OK")<>-1):
      print "| [SIM900] Modem online..";
      return 1
   elif str((response.find("OK"))=='-1'):
      print "| [SIM900] Modem offline..";
      return 0
   ser.close()
# ----------------------------------------------
init_SIM900() # GPIO konfigurieren
PowerOn_SIM900() # SIM900 Modem einschalten
time.sleep(delay) # bisserl warten
#print "warte noch weitere 30 Sekunden bis zum Ausschalten"
#time.sleep(30)
PowerOff_SIM900() # Ausschaltvorgang anwerfen
#Reset_SIM900()
GPIO.cleanup() # GPIO aufraeumen 
# ----------------------- EOF ---------------------------
