# -*- coding: utf-8 -*- 
#!/usr/bin/python
# E.F.Engelhardt, Franzis Verlag, 2016/2017
# ----------------------------------------------------------------------- 
# Funktion watermotor2.py fuer Wasserpumpe mit Bremse ;)
#
import RPi.GPIO as GPIO 
import time
#
# Funktion motoran Einschalten / 2 Sekunden / Ausschalten / 2 Sekunden
#
def watermotor_on(ena_water_pin, sec):
        GPIO.output(ena_water_pin,GPIO.HIGH)
	print "-----------------------"
	print "| Pumpe an            |"
        print "-----------------------"
        time.sleep(sec)
	return 
def watermotor_off(ena_water_pin, sec):
        GPIO.output(ena_water_pin,GPIO.LOW)
        print "-----------------------"
        print "| Pumpe aus           |"
        print "-----------------------"
        time.sleep(sec)
        return 
def watermotor_pause(ina1_water_pin, ina2_water_pin, dir):
        GPIO.output(ina1_water_pin,GPIO.HIGH)
        GPIO.output(ina2_water_pin,GPIO.HIGH)
        print "Wasserpumpe-Pause"
        print "-------------------------------------------------------------"
        return 
def focus(focus_pin):
        GPIO.output(focus_pin,GPIO.HIGH)
        time.sleep(sec)
        GPIO.output(focus_pin,GPIO.LOW)
        time.sleep(sec)
        return 
def foto(shutter_pin):
        GPIO.output(shutter_pin,GPIO.HIGH)
        time.sleep(1.0)
        GPIO.output(shutter_pin,GPIO.LOW)
        print "-----------------------"
        print "| FOTO                |"
        print "-----------------------"
        return 
def setup(ina1_water_pin, ina2_water_pin, ena_water_pin, shutter_pin, focus_pin):
        #
        # Hier wird die PIN-Nummerierung des Raspberry Pi verwendet und NICHT die GPIO-Nummerierung
        GPIO.setmode(GPIO.BOARD)
        # Definition der Pins im Boardmode .
        GPIO.setup(ena_water_pin, GPIO.OUT)
        GPIO.setup(ina1_water_pin, GPIO.OUT)
        GPIO.setup(ina2_water_pin, GPIO.OUT)
        GPIO.setup(shutter_pin, GPIO.OUT)
        GPIO.setup(focus_pin, GPIO.OUT)
        print "ena_water_pin auf ", ena_water_pin, " gesetzt"
		print "ina1_water_pin auf ", ina1_water_pin, " gesetzt"
		print "ina2_water_pin auf ", ina2_water_pin, " gesetzt"
        print "shutter_pin auf ", shutter_pin, " gesetzt"
        print "focus_pin auf ", focus_pin, " gesetzt"
        return 
def motorrrichtung(ina1_water_pin, ina2_water_pin, dir):
        if dir == 1:
                GPIO.output(ina1_water_pin,GPIO.LOW)
                print "ina1_water_pin auf LOW"
                GPIO.output(ina2_water_pin,GPIO.HIGH)
                print "ina2_water_pin auf HIGH"
        else:
                GPIO.output(ina1_water_pin,GPIO.HIGH)
                print "ina1_water_pin auf HIGH"
                GPIO.output(ina2_water_pin,GPIO.LOW)
                print "ina2_water_pin auf LOW"
        print "Richtung-Setzen erledigt"
        print "-------------------------------------------------------------"
        return 
def waterphoto_alt(ena_water_pin, anzahl, abstand, ina1_water_pin, ina2_water_pin, richtung, shutter_pin, focus_pin):
		# drehrichtung einstellen
		motorrrichtung(ina1_water_pin, ina2_water_pin, richtung)
        for i in range (0, anzahl):
		# wassertropfen rauslassen
		# motorrrichtung(ina1_water_pin, ina2_water_pin, richtung)
		#motorrrichtung(ina1_water_pin, ina2_water_pin, richtungzu)
		watermotor_on(ena_water_pin, 0.0001)
                # foto ausloesen
                focus(focus_pin)
                foto(shutter_pin)
		watermotor_off(ena_water_pin, 0)
                print "Foto", "Nr.", i+1 , "von :", anzahl
                print "--------------------------------"
                time.sleep(abstand)
		watermotor_off(ena_water_pin, 0)
        return
def waterphoto(ena_water_pin, anzahl, abstand, ina1_water_pin, ina2_water_pin, richtung, shutter_pin, focus_pin):
        watermotor_on(ena_water_pin, 0.0001)
        for i in range (0, anzahl):
                # drehrichtung einstellen
                motorrrichtung(ina1_water_pin, ina2_water_pin, richtung)
                # foto ausloesen
                focus(focus_pin)
                foto(shutter_pin)
                watermotor_pause(ina1_water_pin, ina2_water_pin, richtung)
                print "Foto", "Nr.", i+1 , "von :", anzahl
                print "--------------------------------"
                time.sleep(abstand)
        watermotor_off(ena_water_pin, 0)
        return
# ------------------------------------------------------------------------------------- 
# Definitionen 
# -------------------------------------------------------------------------------------
ena_water_pin=22 
ina1_water_pin=24 
ina2_water_pin=21 
shutter_pin = 12 
focus_pin = 11
# GPIO_ENA_WATER=25 # pin 22 = GPIO25 - wiring pi 6 - AUSGANG 
# GPIO_INA1_WATER=8 # pin 24 = GPIO8 - wiring pi 10 - AUSGANG 
# GPIO_INA2_WATER=9 # pin 21 = GPIO8 - wiring pi 21 - AUSGANG 
# GPIO_SHUTTER=18 # Pin 12 = GPIO18 - wiring pi 1 - AUSGANG 
# GPIO_FOCUS=17 # Pin 11 = GPIO17 - wiring pi 0 - AUSGANG 
# ------------------------------------------------------------------------------------- 
# initialisieren
#
setup(ena_water_pin, ina1_water_pin, ina2_water_pin, shutter_pin, focus_pin)
# -------------------------------------------------------------------------------------
#  Dreh-Richtung einstellen
# 
# 1 = links - motor zurueck 0 = rechts - motor vorwaerts
richtung = 0
# anzahl Aufnahmen
anzahl = 10
# zeitlicher Abstand zwischen Aufnahmen in millisekunden sec
abstand = 0.2
sec=0.002
# ------------------------------------------------------------------------------------- 
# aufruf slider
waterphoto(ena_water_pin, anzahl, abstand, ina1_water_pin, ina2_water_pin,richtung, shutter_pin, focus_pin)
# --------------------------------------------------------------------------------------
#  Fertig -> Aufrauemen
print "-------------------------------------------------------------------------------------"
print "FERTIG- AUFRAEUMEN"
if GPIO.input(ena_water_pin):
	print "ena_water_pin auf Pin ", ena_water_pin, " ist HIGH"
else:
        print "ena_water_pin auf Pin ", ena_water_pin, " ist LOW"
if GPIO.input(ina1_water_pin):
        print "ina1_water_pin auf Pin ", ina1_water_pin, " ist HIGH"
else:
        print "ina1_water_pin auf Pin ", ina1_water_pin, " ist LOW"
if GPIO.input(ina2_water_pin):
        print "ina2_water_pin auf Pin ", ina2_water_pin, " ist HIGH"
else:
        print "ina2_water_pin auf Pin ", ina2_water_pin, " ist LOW"
if GPIO.input(shutter_pin):
        print "shutter_pin auf Pin ", shutter_pin, " ist HIGH"
else:
        print "shutter_pin auf Pin ", shutter_pin, " ist LOW"
if GPIO.input(focus_pin):
        print "focus_pin auf Pin ", focus_pin, " ist HIGH"
else:
        print "focus_pin auf Pin ", focus_pin, " ist LOW"
print "-------------------------------------------------------------------------------------"
GPIO.cleanup()
# ------------------------------ EOF ---------------------------------------------------
